#include "myfndt.h"
#include "conveyor.h"

//#define DEBUG_fault

#if defined(DEBUG_fault)
long Counter = 0;
#endif

CConveyor::CConveyor(short MaxManipCount):
	ActiveArr(MaxManipCount, 0),
	OwningArr(MaxManipCount, 0),
	Index(-1)
{
}

CConveyor::~CConveyor()
{
	int Count = ActiveArr.GetCount();
	for (int i = Count - 1; i >= 0; i--)
		ActiveArr.DetachByIndex(i);
}

void CConveyor::AddNew(CManipulator *Manipulator)
{
	OwningArr.Add(Manipulator);
	AddOld(Manipulator);
}

void CConveyor::AddOld(CManipulator *Manipulator)
{
	ActiveArr.Add(Manipulator);
	if (Index == -1)
		Index = 0;
}

short CConveyor::Spin(short StepCount)
{
#if defined(DEBUG_fault)
	int dummy = 0;
#endif
	short i = 0;
	do
	{
#if defined(DEBUG_fault)
		printf("%ld\n", Counter);
		if (Counter == 39804l)
			dummy = 1;
		++Counter;
#endif
		  if (Index == -1)
			return 1;

		if (ActiveArr[Index]->Shuffle())
			// shuffle can wake other manipulators
			ActiveArr.DetachByIndex(Index);

		int Count = ActiveArr.GetCount();
		if (Count)
		{	if ((++Index) >= Count)
				Index = 0;
		}
		else
			Index = -1;

	}	while ((++i) != StepCount);
	// can get here if StepCount == 0, when i overflows!
	return 0;
}

