#include "myfndt.h"
#include "ffinder.h"
#include "sortdir.h"

#include <string.h>
#include <stdlib.h>

//#define DEBUG_dirtree

CFileFinder::CFileFinder(CReporter *aReporter,
	COutQueue &aOutQueue,
	DArray<DString> aSourceDirList,
	DArray<DString> aSourceMaskList):
	CSource<DString>(aReporter, aOutQueue),
	SourceDirList(aSourceDirList),
	DirIterator(SourceDirList.InitIterator()),
	SourceMaskList(aSourceMaskList),
	MaskIterator(SourceMaskList.InitIterator()),
	PrepFile(""),
	Product((ushort)(aSourceDirList.GetCount() *
   		aSourceMaskList.GetCount())),
	Progress(0),
	Directory(NULL)
{
	FillPrepFile();
}

CFileFinder::~CFileFinder()
{
	delete Directory;
}

short CFileFinder::IsFilled()
{
	return !PrepFile.IsEmpty();
}

DString *CFileFinder::NewOut()
{
	Assert(!PrepFile.IsEmpty());
	DString *NewFile = new DString(PrepFile);
	PrepFile = "";
	FillPrepFile();
	return NewFile;
}

short CFileFinder::GetPerc()
{
	if (!Product)
		return 100;
	return (short)((100 * Progress) / Product);
}

void CFileFinder::FillPrepFile()
{
    Assert(PrepFile.IsEmpty());
    if (Directory)
    {   PrepFile = Directory->ReadNext();
#if defined(DEBUG_dirtree)
	   if (!PrepFile.IsEmpty())
		  printf("found %s\n", PrepFile.c_str());
#endif
    }

    while (PrepFile.IsEmpty())
    {   delete Directory;
	   Directory = NewNextDir();
	   if (!Directory)
		  return;

	   PrepFile = Directory->ReadNext();
#if defined(DEBUG_dirtree)
	   if (!PrepFile.IsEmpty())
		  printf("found %s\n", PrepFile.c_str());
#endif
	}
}

CSortedDirectory *CFileFinder::NewNextDir()
{
	Assert(SourceDirList.IsDereferenceable(DirIterator));
	if (!SourceMaskList.IsDereferenceable(MaskIterator))
	{	++DirIterator;
		if (!SourceDirList.IsDereferenceable(DirIterator))
			return NULL;
		MaskIterator = SourceMaskList.InitIterator();
		Assert(SourceMaskList.IsDereferenceable(MaskIterator));
	}

	DString &CurDir = SourceDirList.GetCurrent(DirIterator);
	DString &CurMask = SourceMaskList.GetCurrent(MaskIterator);
	++MaskIterator;

	return new CSortedDirectory(CurDir, CurMask);
}

