#include "myfndt.h"
#include "filesiv.h"
#include "filebase.h"

CFileSieve::CFileSieve(CInQueue &aInQueue,
	COutQueue &aOutQueue,
	CFileBase &aFileBase):
	CTransmission<DString, CGlobalFile>(NULL,
			// CFileSieve does not report progress
		aInQueue,
		aOutQueue),
	FileBase(aFileBase), PreparedFile(NULL)
{
}

CFileSieve::~CFileSieve()
{
}

short CFileSieve::IsFilled()
{
	return PreparedFile != NULL;
}

void CFileSieve::SetIn(DString *InFile)
{
	Assert(!PreparedFile);

	// check whether file already exists
	if (FileBase.Has(*InFile))
	{	delete InFile;
		return;
	}

	PreparedFile = new CGlobalFile(*InFile);
	delete InFile;
}

CGlobalFile *CFileSieve::NewOut()
{
	CGlobalFile *NewFile = PreparedFile;
	PreparedFile = NULL;
	return NewFile;
}

