#include "myfndt.h"
#include "growsl.h"
#include "stoplist.h"
#include "idxstor.h"
#include "filestat.h"

#include <ctype.h>

static short GetLine(CFileBufRead &FileStatus, DString &StopWord);

static void GrowStep(CStopList *StopList,
	const DString &StopWord,
	CIndexStorage *IndexStorage);

void GrowStopList(CStopList *StopList,
	const DString &StopListSource,
	CIndexStorage *IndexStorage)
{	DString StopWord;

	CFileBufRead FileStatus;
	FileStatus.SetIn(StopListSource);
	while (!GetLine(FileStatus, StopWord))
		GrowStep(StopList, StopWord, IndexStorage);
	if (!StopWord.IsEmpty())
		GrowStep(StopList, StopWord, IndexStorage);
	StopList->StoreAll();
	IndexStorage->StoreAll();
}

static short GetLine(CFileBufRead &FileStatus, DString &StopWord)
{	char c;
	short eof;

	StopWord = "";
	while ((eof = FileStatus.GetChar(c)) == 0 &&
		!isspace(c))
		StopWord += c;
	if (eof)
		return 1;
	while (c != '\n' &&
	    (eof = FileStatus.GetChar(c)) == 0);
	return eof;
}

static void GrowStep(CStopList *StopList,
	const DString &StopWord,
	CIndexStorage *IndexStorage)
{
	if (!StopList->Add(StopWord))
		IndexStorage->DelWord(StopWord);
}

