#include "myfndt.h"
#include "indexer.h"
#include "idxstor.h"
#include "stoplist.h"
#include <stdlib.h>
#include <string.h>
#include "trace.h"

/* profile 27. 10. 97: moving stop list (757 words) from CWordSieve here
cut time to index 1 649 502 bytes in 2 files (VIRUS-L texts) from 10 to
7 minutes; besides, it's a bug to have stop list before stemming */
CIndexer::CIndexer(CReporter *aReporter,
	CInQueue &aInQueue,
	CStopList *aStopList,
	CIndexStorage &aStorage):
	Storage(aStorage),
	StopList(aStopList),
	CSink<COccBlock>(aReporter, aInQueue),
	OccBlock(NULL),
	BlockSize(0)
{
}

CIndexer::~CIndexer()
{
	delete OccBlock;
}

short CIndexer::IsFilled()
{
	return OccBlock != NULL;
}

short CIndexer::GetPerc()
{
	if (!OccBlock || !BlockSize)
		return 0;
	int Count = OccBlock->GetCount();
	return (short)(100 - ((100 * Count) / BlockSize));
}

void CIndexer::SetIn(COccBlock *InOccBlock)
{
	Assert(!OccBlock);
	Assert(!InOccBlock->IsEmpty());
	OccBlock = InOccBlock;
	BlockSize = OccBlock->GetCount();
    TRACELOG(LOG_DEBUG, "indexing %d words\n", BlockSize);
}

void CIndexer::Step()
{	ushort OccCount;

	Assert(OccBlock != NULL);
	CObjPtr<CComposedOcc> Occ = OccBlock->NewComposedOcc();

	DString CurWord = Occ->GetWord();
	if (StopList == NULL || !StopList->Has(CurWord))
        Storage.IndexWord(CurWord, Occ->GetOccs());

	if (OccBlock->IsEmpty())
	{	delete OccBlock;
		OccBlock = NULL;
	}
}

void CIndexer::CleanUp()
{
	CSink<COccBlock>::CleanUp();
	Storage.StoreAll();
}


