#if !defined(__indexer_h)
#define __indexer_h

#include "sink.h"
#include "occmap.h"
#include "tl.h"
#include "mconduct.h"

class CIndexStorage;
class CStopList;

class CIndexer : public CSink<COccBlock>
{
private:
	CIndexStorage &Storage;
	COccBlock *OccBlock;
	int BlockSize;
	CStopList *StopList;
		// can be NULL
		// alias; do not delete!

public:
	CIndexer(CReporter *aReporter,
		CInQueue &aInQueue,
		CStopList *aStopList,
		CIndexStorage &aStorage);
	virtual ~CIndexer();

protected:
	virtual short IsFilled();
	virtual short GetPerc();
	virtual void SetIn(COccBlock *InOccBlock);
	virtual void Step();
	virtual void CleanUp();
};

#endif

