#if !defined(__manip_h)
#define __manip_h

#include "reporter.h"

class CManipulator
{
private:
	CReporter *Reporter;

public:
	// takes ownership of reporter
	CManipulator(CReporter *aReporter);
	virtual ~CManipulator();

protected:
	virtual short IsFilled() = 0;
	virtual short GetPerc() { return 0; }
public:
	virtual short Shuffle() = 0;
protected:
	virtual void CleanUp(); // empty

protected:
	void ReportProgress(short IsActive, unsigned short Perc)
		{ if (Reporter) Reporter->ReportProgress(IsActive, Perc); }
	void ReportIn()
		{ if (Reporter) Reporter->ReportIn(); }
	virtual void InformNext() = 0; 

public:
	int operator == (const CManipulator &Other) const
		{ return (ulong)this == (ulong)(&Other); }
	int operator < (const CManipulator &Other) const
		{ return (ulong)this < (ulong)(&Other); }

private:
	CManipulator(const CManipulator &); // not defined/not usable
};

#endif

