#if !defined(__occbuild_h)
#define __occbuild_h

#include "occdatum.h"

class COccBuilder : public COccDatum
{
// consts & types
private:
	static const int MarginThreshold;
	static const int AQuotient;
	static const double BQuotient;
	static const int SettledThreshold;

public:
	COccBuilder(CStorage *aStorage, long aTicket);
	virtual ~COccBuilder();

	virtual long Finish();

	void Add(ulong *OccArray, int Count);

private:
	long AddNew(ulong *OccArray, int Count);
	long AddEx(ulong *OccArray, int Count);
	long AddNewTicket(ulong *Occ1,
		int Count1,
		ulong *Occ2,
		int Count2);
	long AddOnTip(long OldTicket,
		long OldCount,
		ulong *OccArray,
		int Count);
	void BuildSecond(long OldTicket,
		long OldCount,
		ulong *OccArray,
		int Count);
	void BuildSegmented(long OldTicket,
		long OldCount,
		ulong *OccArray,
		int Count);
	void BuildExSegment(STail &Tail, // in & out param
		long TipCount,
		ulong *OccArray,
		int Count);
	void BuildNewSegment(STail &Tail, // in & out param
		ulong *OccArray,
		int Count);
	ulong GetOldTipMoved(long OldTipTicket);
	void SetOldInnerLastNext(long InnerLastTicket,
		long NextTicket);

	long RoundMargin(long Size, long OldMargin);

	void MakeRoom(long CurTicket,
		long CurCount,
		ulong *DestBuf,
			// out: occurences from the end of CurTicket
		int &DestBufCount,
			// in: DestBuf size (in sizeof(ulong))
			// out: number of occurences filled
		ulong *&SrcPadding,
			// in: occurences to add
			// out: occurences which were not added
		int &SrcPaddingCount);
			// in & out: number of items of SrcPadding
		// when using up all padding, updates count on disk
};

#endif

