#if !defined(__occsort_h)
#define __occsort_h

#include "transmt.h"
#include "socc.h"
#include "occmap.h"

class CAbstractStemmer;

class COccSorter : public CTransmission<CSimpleOcc, COccBlock>
{
private:
    COccBlock *OccBlock;
    int BlockSize;
    int ColSize;
#if defined(TWOWAYBLOCK)
    bool Forward;
#endif
    CAbstractStemmer *Stem;

public:
    COccSorter(CReporter *aReporter,
	   CInQueue &aInQueue,
	   COutQueue &aOutQueue,
	   int aBlockSize,
	   int aColSize,
	   CAbstractStemmer *InStem);
		  // deleted in COccSorter::~COccSorter()
	virtual ~COccSorter();

protected:
	virtual short IsFilled();
	virtual short GetPerc();
	virtual void SetIn(CSimpleOcc *InOcc);
	virtual COccBlock *NewOut();
};

#endif

