#include "myfndt.h"
#include "queuec.h"
#include "conveyor.h"

/*#if !defined(_MSC_VER)
#include <alloc.h>
#include <mem.h>
#endif*/
#include <stdlib.h>
#include <string.h>

CQueueCode::CQueueCode(short aMaxLength, CConveyor &aConveyor):
	MaxCount(aMaxLength),
	Count(0),
	Array(NULL),
	BlockedOnGet(NULL),
	BlockedOnPut(NULL),
	Conveyor(aConveyor),
	SourceDone(0)
{
	if ((Array = (void **)malloc(MaxCount * sizeof(void *))) == NULL)
		throw DMemoryException(MaxCount * sizeof(void *));
	memset(Array, 0, MaxCount * sizeof(void *));
}

CQueueCode::~CQueueCode()
{
	free(Array);
}

void CQueueCode::Put(void *Item)
{
	Assert(!IsFull());
	memmove(Array + 1, Array, Count * sizeof(void *));
	Array[0] = Item;
	Count++;
	if (BlockedOnGet)
	{	CManipulator *Manipulator = BlockedOnGet;
		BlockedOnGet = NULL;
		Conveyor.AddOld(Manipulator);
	}
}

void *CQueueCode::Get()
{
	Assert(!IsEmpty());
	void *Item = Array[Count - 1];
	Array[Count - 1] = NULL;
	Count--;
	if (BlockedOnPut)
	{	CManipulator *Manipulator = BlockedOnPut;
		BlockedOnPut = NULL;
		Conveyor.AddOld(Manipulator);
	}
	return Item;
}

void CQueueCode::SetBlockedOnGet(CManipulator *Manipulator)
{
	Assert(!BlockedOnGet);
	BlockedOnGet = Manipulator;
}

void CQueueCode::SetBlockedOnPut(CManipulator *Manipulator)
{
	Assert(!BlockedOnPut);
	BlockedOnPut = Manipulator;
}

void CQueueCode::Wake()
{
	Assert(!BlockedOnPut);
	if (BlockedOnGet)
	{	CManipulator *Manipulator = BlockedOnGet;
		BlockedOnGet = NULL;
		Conveyor.AddOld(Manipulator);
	}
}
