#if !defined(__queuec_h)
#define __queuec_h

class CManipulator;
class CConveyor;

class CQueueCode
{
private:
	short MaxCount;
protected:
	short Count;
	void **Array;
		// destructor of derived class must delete array items

private:
	CManipulator *BlockedOnGet;
	CManipulator *BlockedOnPut;
	CConveyor &Conveyor;
	short SourceDone;

public:
	CQueueCode(short aMaxLength, CConveyor &aConveyor);
	virtual ~CQueueCode();

	int IsEmpty()
		{ return !Count; }
	int IsFull()
		{ return Count == MaxCount; }

protected: // untyped versions, redefined in derived class
	void Put(void *Item);
	void *Get();

public:
	void SetBlockedOnGet(CManipulator *Manipulator);
	void SetBlockedOnPut(CManipulator *Manipulator);

	void Wake();

	void SetSourceDone() { SourceDone = 1; }
	short IsSourceDone() { return SourceDone; }
};

#endif

