#if !defined(__rdisp_h)
#define __rdisp_h

#include "branch.h"
#include "globfile.h"
#include "socc.h"
#include "cluster.h"
#include "procfile.h"

class CReader;
class CDecompressor;
class CCruncherOptions;
class CSubDesc;

class CReaderDispatch : public CBranch<CGlobalFile, CSimpleOcc,
		CCluster, CProcessedFile>
{
private:
	CReader *Reader;
	CGlobalFile *CurFile;
	CSimpleOcc *PreparedOcc;
	CCluster *PreparedCluster;
	CProcessedFile *PreparedFile;
	short NextLine;
	ulong WordNum;
	ulong GlobalDelta;
	long DivisionOffs;
	int ClusterCounter;
	int ClusterCounterMax;
	CDecompressor *Decompressor;
	int ReserveCounter;
	const int ReserveCounterMax;
        CSubDesc *SubDesc;

public:
	CReaderDispatch(CReporter *aReporter,
		CInQueue &aInQueue,
		COutQueue &aOutQueue,
		COutQueue1 &aOutQueue1,
		COutQueue2 &aOutQueue2,
		ulong StartWordNum,
		CDecompressor *aDecompressor,
			// owned by this
		CCruncherOptions &Options);
	virtual ~CReaderDispatch();

protected:
	virtual short IsFilled();
	virtual void SetIn(CGlobalFile *GlobalFile);
	virtual void NewOut(CSimpleOcc **SimpleOcc,
			CCluster **Cluster, CProcessedFile **ProcessedFile);
	virtual short GetPerc();

private:
    void FillPrepOcc();
    void DocBegin();
    int HandleWordEndsDoc(long Offs);
    void FillPreparedDoc();
    void AddSubdoc();
};

#endif

