#if !defined(__sink_h)
#define __sink_h

#if defined(EXTERNAL_TEMPLATES)
#pragma interface
#endif

#include "manip.h"
#include "lqueue.h"

//#define DEBUG_CClusterWriter

template<class CInItem>
class CSink : public CManipulator
{
public:
	typedef CQueue<CInItem> CInQueue;

#if !defined(DEBUG_CClusterWriter)
private:
#else
protected:
#endif
	CInQueue &InQueue;

public:
	CSink(CReporter *aReporter, CInQueue &aInQueue);
	virtual ~CSink() { }

	virtual short Shuffle();

protected:
	virtual void SetIn(CInItem *InItem) = 0;
		// must delete InItem

	virtual void Step() = 0;
	virtual void InformNext(); // empty

	short ShuffleIn();
	short IsSourceDone() { return InQueue.IsSourceDone(); }
};

template<class CInItem>
CSink<CInItem>::CSink(CReporter *aReporter,
	CQueue<CInItem> &aInQueue):
	CManipulator(aReporter),
	InQueue(aInQueue)
{
}

template<class CInItem>
short CSink<CInItem>::Shuffle()
{
	if (!IsFilled())
	{	ReportIn();
		return ShuffleIn();
	}
	else
	{  Step();
		ReportProgress(1, GetPerc());
		return 0;
	}
}

template<class CInItem>
void CSink<CInItem>::InformNext()
{
}

template<class CInItem>
short CSink<CInItem>::ShuffleIn()
{
	if (InQueue.IsEmpty())
	{	if (IsSourceDone())
		{  CleanUp();
			InformNext();
			return 2;
		}
		else
		{	InQueue.SetBlockedOnGet(this);
			return 1;
		}
	}
	CInItem *InItem = InQueue.Get();
	SetIn(InItem);
	return 0;
}

#endif

