#if !defined(__source_h)
#define __source_h

#if defined(EXTERNAL_TEMPLATES)
#pragma interface
#endif

#include "manip.h"
#include "lqueue.h"

template<class COItem>
// if the parameter is called COutItem, gcc 2.7.2.1 has trouble with it
class CSource : public CManipulator
{
public:
	typedef CQueue<COItem> COutQueue;

private:
	COutQueue &OutQueue;

public:
	CSource(CReporter *aReporter,	COutQueue &aOutQueue);
	virtual ~CSource();

	virtual short Shuffle();

protected:
	virtual COItem *NewOut() = 0;
	virtual void InformNext();
	virtual void CleanUp();
};

template<class COItem>
CSource<COItem>::CSource(CReporter *aReporter,
	CQueue<COItem> &aOutQueue):
	CManipulator(aReporter),
	OutQueue(aOutQueue)
{
}

template<class COItem>
CSource<COItem>::~CSource()
{
}

template<class COItem>
short CSource<COItem>::Shuffle()
{
	if (!IsFilled())
	{  CleanUp();
		InformNext();
		return 2;
	}
	else
	{	// this code is duplicated in CTransmission
		if (OutQueue.IsFull())
		{	//ReportProgress(0, GetPerc());
			OutQueue.SetBlockedOnPut(this);
			return 1;
		}

		ReportIn();
		COItem *OutItem = NewOut();
		OutQueue.Put(OutItem);
		ReportProgress(1, GetPerc());
		return 0;
	}
}

template<class COItem>
void CSource<COItem>::CleanUp()
{
	CManipulator::CleanUp();
	OutQueue.Wake();
}

template<class COItem>
void CSource<COItem>::InformNext()
{
	OutQueue.SetSourceDone();
}

#endif

