#if !defined(__wordsiv_h)
#define __wordsiv_h

#include "transmt.h"
#include "socc.h"

class CPunctAxe;
class CAbstractCase;
class CCruncherOptions;

class CWordSieve : public CTransmission<CSimpleOcc, CSimpleOcc>
{
private:
	CSimpleOcc *Occ;
	CPunctAxe *PunctAxe;
	CAbstractCase *Case;
	int IndexedLength;
	int MaxWordLength;

public:
	CWordSieve(CInQueue &aInQueue,
		COutQueue &aOutQueue,
		CAbstractCase *aCase,
			// deleted in CWordSieve::~CWordSieve()
		CCruncherOptions &Options);
	virtual ~CWordSieve();

protected:
	virtual short IsFilled();
	virtual void SetIn(CSimpleOcc *InOcc);
	virtual CSimpleOcc *NewOut();
};

#endif
