#include "myfndt.h"
#include "ande.h"

CAndExpr::CAndExpr(CSubFormula *InLeft, CSubFormula *InRight):
    CBinaryFormula(InLeft, InRight)
{
}

int CAndExpr::IsRelevant(CDocWrapper *DocWrapper, double &Relevance)
{   double LeftRel, RightRel;

    if (!Left->IsRelevant(DocWrapper, LeftRel) ||
	   !Right->IsRelevant(DocWrapper, RightRel))
	   return 0;

    Assert(-0.01 < LeftRel && LeftRel < 1.01);
    Assert(-0.01 < RightRel && RightRel < 1.01);
    Relevance = LeftRel < RightRel ? LeftRel : RightRel;
    return 1;
}
