#include "myfndt.h"
#include "clot.h"
#include "spot.h"

const int CClot::DefaultLimit = 3;
const int CClot::DefaultDelta = 10;

CClot::CClot(short aFirstLow,
	CSpot *aLastSpot,
	int aLimit,
	int aDelta):
	Passage(aLimit, aDelta),
	FirstLow(aFirstLow),
	LastSpot(aLastSpot),
	UserHead("")
{
}

CClot::~CClot()
{
	delete LastSpot;
}

void CClot::Add(DString &aPassage)
{
	Passage.Add(new DString(aPassage));
}

short CClot::GetPassage(int Index, DString &aPassage)
{
     if (IsDouble())
	{    if (Index)
		     return 1;
	     else
		{    aPassage = UserHead;
			return 0;
		}
	}

	if (Index >= Passage.GetCount())
		return 1;
	aPassage = *(Passage[Index]);
	return 0;
}

void CClot::AddUserHead(DString &aPassage)
{
     Assert(UserHead.IsEmpty() && !aPassage.IsEmpty());
	UserHead = aPassage;
}

void CClot::Regularize()
{
     Assert(!UserHead.IsEmpty());
	UserHead = "";
}

short CClot::GetFirstLow()
{
     if (IsDouble())
	     return 1;

	return FirstLow;
}

CSpot *CClot::GetLastSpot() 
{ 
     Assert(!IsDouble());
     return LastSpot; 
}
