#include "myfndt.h"
#include "compprov.h"
#include "reporter.h"

CComposedProvider::CComposedProvider(CWordProvider *InIntern,
    CReporter &Reporter,
    const DString &TmpDir):
    Intern(InIntern),
    Sorter(new CStringHandler(6),
	   TmpDir,
	   IT_TEMP | IT_UPDATE)
{
    DString ItrWord = "";
    while (!Intern->GetWord(ItrWord))
    {   CNewKey Key(CStringHandler::NewKey(ItrWord.c_str()));
	   Sorter.Add(Key, 3);
	   Reporter.ReportProgress(1, Intern->GetPerc(ItrWord));
    }
}

int CComposedProvider::GetWord(DString &ItrWord)
{
    if (ItrWord.IsEmpty())
    {   CLockedKey Key(Sorter.LockFirstKey(), &Sorter);
	   if (!Key)
		  return 1;

	   ItrWord = CStringHandler::GetString(Key);
	   return 0;
    }
    else
    {   CNewKey OldKey(CStringHandler::NewKey(ItrWord.c_str()));
	   CLockedKey Key(Sorter.LockNextKey(OldKey), &Sorter);
	   if (!Key)
		  return 1;

	   ItrWord = CStringHandler::GetString(Key);
	   return 0;
    }
}
