#include "myfndt.h"
#include "docum.h"
#include "tl.h"

DDocument::DDocument(CAnswer *aLockedAnswer,
	CStorage &aStorage,
	ulong aDocNum,
	long aRelevance,
	int aTransient):
	LockedAnswer(aLockedAnswer),
	Storage(aStorage),
	DocNum(aDocNum),
	Relevance(aRelevance),
	Transient(aTransient)
{
}

DDocument::~DDocument()
{
    Storage.Unlock(LockedAnswer);
    if (Transient)
    {   CNewKey Key(CULongHandler::NewKey(DocNum));
	   short KnownRet = Storage.Del(Key);
	   Assert(!KnownRet);
    }
}

CRelevance *DDocument::GetRelObj()
{
	return LockedAnswer->GetRelevance();
}

// inverse of CResult::ConvertRelevance
double DDocument::GetRelRes()
{
    return -static_cast<double>(Relevance) / 100000;
}

