#if !defined(__docum_h)
#define __docum_h

#include "mconduct.h"
#include "answer.h"

class CHitBag;
class CRelevance;

class DDocument
{
private:
	CAnswer *LockedAnswer;
	CStorage &Storage;
	ulong DocNum;
	long Relevance;
	int Transient;

public:
	// takes ownership of locked answer
	DDocument(CAnswer *aLockedAnswer,
		CStorage &aStorage,
		ulong aDocNum,
		long aRelevance = 0, // 0 means invalid
		int aTransient = 0);
	// unlocks the answer
	virtual ~DDocument();

	CAnswer *GetAnswer() { return LockedAnswer; }
	ulong GetNum() { return DocNum; }

	long GetRelevance() { return Relevance; }
     CRelevance *GetRelObj();
     double GetRelRes();
};

#endif
