#include "myfndt.h"
#include "fileprov.h"
#include "grazeopt.h"
#include "newcase.h"
#include "newstem.h"
#include "watch.h"

#include "opunct.h"
#include "ocase.h"
#include "oreader.h"

CFileProvider::CFileProvider(const DString &FName,
    CGrazerOptions &Options):
    Reader(Options.Get(O_SEPARATORS), new CWatch()),
    PunctAxe(Options.Get(O_PUNCT)),
    Case(NewCaseStandard(Options.COptions<int>::Get(O_EARLYCASECONV))),
    Stem(NewStemmer(Options))
{
    Reader.SetIn(FName, 0);
}

CFileProvider::~CFileProvider()
{
}

int CFileProvider::GetWord(DString &ItrWord)
{   long Offs;

    do
    {   CReader::EShiftRes ShiftRes = Reader.SkipWhite(Offs);
	   if (ShiftRes == CReader::at_eof)
		  return 1;

	   Reader.GetWord(ItrWord);
	   if (ItrWord.IsEmpty())
		  return 1;

    }   while (PunctAxe.AxePunct(ItrWord));

    Case->Confine(ItrWord);
    Stem->Apply(ItrWord);
    return 0;
}

short CFileProvider::GetPerc(const DString &)
{
    return Reader.GetPerc();
}
