#if !defined(__fileprov_h)
#define __fileprov_h

#include "wordprov.h"
#include "preader.h"
#include "punctaxe.h"
#include "abstcase.h"
#include "abststem.h"

class CGrazerOptions;
class CAbstractStemmer;

class CFileProvider : public CWordProvider
{
public:
    CFileProvider(const DString &FName, CGrazerOptions &Options);
    virtual ~CFileProvider();

    // returns 0 OK (out param valid), 1 no more words
    virtual int GetWord(DString &ItrWord);

    virtual short GetPerc(const DString &ItrWord);

private:
    CReader Reader;
    CPunctAxe PunctAxe;
    CObjPtr<CAbstractCase> Case;
    CObjPtr<CAbstractStemmer> Stem;
};

#endif
