#include "myfndt.h"
#include "fritem.h"

CFrontItem::CFrontItem(const DString &aWordVariation, 
    short aMajorIndex):
    WordVariation(aWordVariation),
    Indices(1, 4),
    OccList(NULL),
    OccItr(0),
    CurrentOcc(0xffffffff)
{
    Indices.Add(aMajorIndex);
}

void CFrontItem::SetOccList(const CDatumEnvelopeTemplate<CFixedOcc> &aOccList)
{
    OccList = aOccList;
    if (!OccList.IsEmpty())
    {
#if defined(DEBUG_CFixedOcc)
	OccList->Check();
#endif
	OccItr = OccList->InitIterator();
	Assert(OccItr != 0);
	CurrentOcc = OccList->GetNext(OccItr);
    }
}

CFrontItem::~CFrontItem()
{
}

int CFrontItem::GetCurOcc(ulong &Occ) const
{
    if (CurrentOcc == 0xffffffff)
	   return 1;
    Occ = CurrentOcc;
    return 0;
}

void CFrontItem::Iterate()
{
    if (CurrentOcc == 0xffffffff)
	   return;
    if (!OccItr)
    {   CurrentOcc = 0xffffffff;
	   return;
    }
    CurrentOcc = OccList->GetNext(OccItr);
}
