#if !defined(__fritem_h)
#define __fritem_h

#include "conduct.h"
#include "fixedocc.h"
#include "arrays.h"

class CFrontItem
{
public:
    CFrontItem(const DString &aWordVariation, 
	   short aMajorIndex);
    ~CFrontItem();
    void SetOccList(const CDatumEnvelopeTemplate<CFixedOcc> &aOccList);

    int operator == (const CFrontItem &Other) const
	  { return WordVariation == Other.WordVariation; }
    int operator < (const CFrontItem &Other) const
	  { return WordVariation < Other.WordVariation; }

    const DString WordVariation;
    DArray<ushort> Indices;

    ushort GetResidentIndex() { return Indices[0]; }

    int GetCurOcc(ulong &Occ) const;
        // returns 0 OK (Occ out param), 1 no more occurences
    void Iterate();

private:
    CDatumEnvelopeTemplate<CFixedOcc> OccList;
    long OccItr;
    ulong CurrentOcc;
};

#endif
