#include "myfndt.h"
#include "gindex.h"

#include <stdlib.h>
#include <string.h>

//#define DEBUG_GetOcc

CGrazeIndex::CGrazeIndex(const DString &aKeyFile,
	const DString &aFreeListFile,
	const DString &aDataFile,
	ushort aAverageWordLen):
	Storage(new CCompressedStrHandler(aAverageWordLen),
		aKeyFile,
		new CDatumFactoryTemplate<CFixedOcc>,
		aFreeListFile,
		aDataFile,
		0)
{
}

CGrazeIndex::~CGrazeIndex()
{
}

CDatumEnvelopeTemplate<CFixedOcc> CGrazeIndex::GetOcc(
	const DString &IndexedWord)
{
#if defined(DEBUG_GetOcc)
     const char *p = IndexedWord.c_str();
#endif
	CNewKey Key(CCompressedStrHandler::NewKey(IndexedWord.c_str()));
	CFixedOcc *Letter = static_cast<CFixedOcc *>(Storage.Lock(Key));
	CDatumEnvelopeTemplate<CFixedOcc> Envelope = Letter;
	return Envelope;
}

int CGrazeIndex::GetFirstWord(DString &ItrWord)
{
	CNewKey Key(Storage.NewFirstKey());
	if (!Key)
		return 1;
	ItrWord = CCompressedStrHandler::GetString(Key);
	return 0;
}

int CGrazeIndex::GetNextWord(DString &ItrWord)
{
	CNewKey NewKey(CCompressedStrHandler::NewKey(ItrWord.c_str()));
	CNewKey NextKey(Storage.NewNextKey(NewKey));
	if (!NextKey)
		return 1;
	ItrWord = CCompressedStrHandler::GetString(NextKey);
	return 0;
}

