#include "myfndt.h"
#include "gridans.h"
#include "wordmask.h"
#include "filter.h"
#include "subdesc.h"

CGridAnswer::CGridAnswer(long DocWordCount,
    CAnswer &aAnswer, 
    CWordMask &aMask,
    CSubdocFilter &Filter,
	CSubDesc &Desc):
    CLineAnswer(0 /* invalid */ , aAnswer, aMask),
    DocMask(Filter, Desc, DocWordCount)
{
    VisibleCount = DocMask.GetVisibleCount();
}

int CGridAnswer::IsVisible(const CAnswer::COcc &Hit)
{
    return WordMask.Has(Hit.GetWordIndex()) && DocMask.Has(Hit.GetOccNum());
}

ulong CGridAnswer::GetConstrictedOcc(CAnswer::COcc &Hit)
{
    return DocMask.Constrict(Hit.GetOccNum());
}

