#if !defined(__interval_h)
#define __interval_h

class CGrazerOptions;
class CFileBase;

class CInterval
{
public:
    CInterval(CFileBase &FileBase,
	   CGrazerOptions &Options);

    int IsUnder(ulong Num);
    int IsOver(ulong Num);

private:
    class CBound
    {   
    public:
	   enum EMode { infinite, interval_closed, interval_opened };  

	   CBound(CFileBase &FileBase,
		   CGrazerOptions &Options,
		   const char *BDFileOptId,
		   const char *BDOffsOptId,
		   const char *BoundaryInIntervalOptId);

	   int Equals(const CBound &Other);
	   int LessThan(const CBound &Other);
	   EMode GetMode();

	   int IsUnder(ulong aNum);
	   int IsOver(ulong aNum);

    private:

	   EMode Mode;  
	   ulong Num;

	   static void ThrowNotFound(const DString ErrFormatSD,
		  const DString &BDFile, 
            int BDOffs);
    };

    CBound Low;
    CBound High;
};

#endif
