#include "myfndt.h"
#include "linedoc.h"

const ulong CLineDoc::TestDocNum = 0xffffffff;
const ulong CLineDoc::TestFirstWord = 0xffffffff;

CLineDoc::CLineDoc(ulong aDocNum, const CFileBase::SFileRecord &aRec):
    DocNum(aDocNum),
    Rec(aRec)
{
}

CLineDoc::CLineDoc(const CLineDoc &LineDoc):
    DocNum(LineDoc.DocNum),
    Rec(LineDoc.Rec)
{
}

CLineDoc::CLineDoc(ulong aDocNum, ulong aFirstWord):
    DocNum(aDocNum)
{
    const_cast<CFileBase::SFileRecord &>(Rec).FirstWord = aFirstWord;
    const_cast<CFileBase::SFileRecord &>(Rec).WordCount = 0;
}

int CLineDoc::operator == (const CLineDoc &Other) const
{ 
    if (DocNum != TestDocNum && Other.DocNum != TestDocNum)
	return DocNum == Other.DocNum;
    else
    {	Assert(Rec.FirstWord != TestFirstWord &&
		  Other.Rec.FirstWord != TestFirstWord);
	return Rec.FirstWord == Other.Rec.FirstWord; // for test items
    }
}  

int CLineDoc::operator < (const CLineDoc &Other) const
{ 
    if (DocNum != TestDocNum && Other.DocNum != TestDocNum)
	   return DocNum < Other.DocNum; 
    else
    {   Assert(Rec.FirstWord != TestFirstWord &&
		  Other.Rec.FirstWord != TestFirstWord);
   	   return Rec.FirstWord < Other.Rec.FirstWord;
    }
} 
