#if !defined(__linedoc_h)
#define __linedoc_h

#include "filebase.h"

class CLineDoc
{
friend class CFrontLine;
public:
    CLineDoc(ulong aDocNum, const CFileBase::SFileRecord &aRec);
    CLineDoc(const CLineDoc &LineDoc);
private:
    CLineDoc(ulong aDocNum, ulong aFirstWord); // for test items only

    static const ulong TestDocNum;
    static const ulong TestFirstWord;

    const ulong DocNum;
    const CFileBase::SFileRecord Rec;

public:
    int operator == (const CLineDoc &Other) const;
    int operator < (const CLineDoc &Other) const; 

    ulong GetBeginOcc() { return Rec.FirstWord; }
    ulong GetEndOcc() { return Rec.FirstWord + Rec.WordCount; }

    ulong GetDocNum() const { return DocNum; }
};

#endif
