#include "myfndt.h"
#include "maskans.h"

CMaskingAnswer::CMaskingAnswer(long VisibleWordsInDocCount, CAnswer &aAnswer):
    VisibleCount(VisibleWordsInDocCount),
    Answer(aAnswer)
{
}

CMaskingAnswer::~CMaskingAnswer()
{
}

long CMaskingAnswer::InitIterator()
{
    long Itr = Answer.InitIterator();
    BumpAnswer(Itr);
    return Itr;
}

CAnswer::COcc CMaskingAnswer::GetHit(long &Itr)
{
    Assert(Itr != 0);
    CAnswer::COcc Guaranteed = Answer.GetHit(Itr);
    Assert(IsVisible(Guaranteed));
    BumpAnswer(Itr);
    return Guaranteed;
}

void CMaskingAnswer::BumpAnswer(long &Itr)
{
    while (Itr)
    {   CAnswer::COcc Current = Answer.Peek(Itr);
        if (IsVisible(Current))
            return;
        Answer.Bump(Itr);
    }
}

ulong CMaskingAnswer::GetConstrictedOcc(long &Iterator)
{
    CAnswer::COcc Hit = GetHit(Iterator);
    return GetConstrictedOcc(Hit);
}

ulong CMaskingAnswer::GetConstrictedOcc(CAnswer::COcc &Hit)
{
    return Hit.GetOccNum();
}

ushort CMaskingAnswer::GetConstrictedIndex(long &Iterator)
{
    CAnswer::COcc Hit = GetHit(Iterator);
    return GetConstrictedIndex(Hit);
}

long CMaskingAnswer::GetVisibleWordsInDocCount() const
{
    return VisibleCount;
}

