#if !defined(__maskans_h)
#define __maskans_h

#include "answer.h"

class CMaskingAnswer
{
public:
    CMaskingAnswer(long VisibleWordsInDocCount, CAnswer &aAnswer);
        // reference must stay valid during life of the object!
    virtual ~CMaskingAnswer();

    long GetVisibleWordsInDocCount() const;

    long InitIterator();
    CAnswer::COcc GetHit(long &Itr); // iterates
    inline void ResetIterator(long Iterator);

    ulong GetConstrictedOcc(long &Iterator); // iterates
    ushort GetConstrictedIndex(long &Iterator); // iterates

    virtual ulong GetConstrictedOcc(CAnswer::COcc &Hit); // does not iterate
    virtual ushort GetConstrictedIndex(CAnswer::COcc &Hit) = 0; // does not iterate

protected:
    long VisibleCount;
    CAnswer &Answer;

    virtual int IsVisible(const CAnswer::COcc &Hit) = 0;

private:
    void BumpAnswer(long &Itr);
};

inline void CMaskingAnswer::ResetIterator(long Iterator)
{
    Answer.ResetIterator(Iterator);
}

#endif
