#include "myfndt.h"
#include "numclot.h"

const int CNumClot::DefaultLimit = 3;
const int CNumClot::DefaultDelta = 10;

CNumClot::CNumClot(CCluster &aHeadCluster,
	int aLimit,
	int aDelta):
	Passage(aLimit, aDelta),
	HeadCluster(aHeadCluster),
	Sum(0),
	FirstHigh(0)
{
}

CNumClot::~CNumClot()
{
}

// untested!
void CNumClot::Add(ulong WordNum)
{
	Assert(WordNum >= HeadCluster.GetFirstWordNum());
	ushort LocCount = static_cast<ushort>(WordNum -
			HeadCluster.GetFirstWordNum());
	ushort Delta = 1 + LocCount - Sum;
	int PassageCount = Passage.GetCount();
	if (PassageCount > 0)
	{	switch (Delta)
		{	case 0: // the same occurence twice
				break;
			case 1: // adjacent occurences
				(Passage[PassageCount - 1])++;
				break;
			default: // separate occurences
				AddSeparate(Delta - 1);
				break;
		}
	}
	else
		AddSeparate(Delta - 1);
	Sum += Delta;
}

short CNumClot::IsFirstLow()
{
	Assert(!Passage.IsEmpty());
	return !FirstHigh;
}

int CNumClot::GetHeadDist()
{
	Assert(!Passage.IsEmpty());
	return Passage[0];
}

short CNumClot::GetPassageCount(ushort Index, ushort &Count)
{
	if (Index >= Passage.GetCount())
		return 1;
	Count = Passage[Index];
	return 0;
}

void CNumClot::AddSeparate(ushort Delta)
{
	if (Delta > 0)
		Passage.Add(Delta);
	else
		FirstHigh = 1;
	Passage.Add(1);
}

