#include "myfndt.h"
#include "ore.h"


COrExpr::COrExpr(CSubFormula *InLeft, CSubFormula *InRight):
    CBinaryFormula(InLeft, InRight)
{
}

int COrExpr::IsRelevant(CDocWrapper *DocWrapper, double &Relevance)
{   double LeftRel, RightRel;

    int ok = 0;
    if (Left->IsRelevant(DocWrapper, LeftRel))
    {   Assert(-0.01 < LeftRel && LeftRel < 1.01);
	ok = 1;
    }
    else
	LeftRel = 0;
    if (Right->IsRelevant(DocWrapper, RightRel))
    {   Assert(-0.01 < RightRel && RightRel < 1.01);
	ok = 1;
    }
    else
	RightRel = 0;
    if (!ok)
	return 0;

    Relevance = LeftRel > RightRel ? LeftRel : RightRel;
    return 1;
}
