#include "myfndt.h"
#include "puparse.h"

CPunctParse::CPunctParse(const DString &aPunct):
    CPunctAxe(aPunct)
{
}

void CPunctParse::ParsePunct(DString &OccWord,
	DString &Before,
	DString &After)
{
    int s = OccWord.GetLength() + 1;
    CMemPtr<char> Buffer(s);
    memcpy((char *)Buffer, OccWord.c_str(), s);
    char *w = (char *)Buffer;

    while (*w && IsPunct(*w))
        ++w;

    if (!(*w))
    {   Before = OccWord;
        OccWord = After = "";
        return;
    }

    char *e = strchr(w, 0) - 1;
    while (IsPunct(*e))
        --e;

    Assert(e >= w);

    char c1 = *w; *w = 0;
    Before = (char *)Buffer;
    *w = c1;

    char c2 = *(e + 1); *(e + 1) = 0;
    OccWord = w;
    *(e + 1) = c2;

    After = e + 1;
}
/*{	int len;

    Before = "";
    After = "";

	while (OccWord.GetLength() > 0 &&
		IsPunct(OccWord[0]))
    {   Before += OccWord[0];
		CutHead(OccWord);
    }

	while ((len = OccWord.GetLength()) > 1 &&
		IsPunct(OccWord[len - 1]))
    {   DString x = OccWord.c_str() + (len - 1);
        After = x + After;
		CutTail(OccWord);
    }
}*/

