#if !defined(__query_h)
#define __query_h

#include "arrays.h"

class CPunctAxe;
class CAbstractCase;
class CAbstractStemmer;

class CQuery
{
private:
	static const int DefaultWordLimit;
	static const int DefaultWordDelta;

// members
private:
	DIArray<DString> **Matrix;
	int MatrixCount;
	int WordLimit;
	int WordDelta;

public:
	CQuery(int aWordLimit = DefaultWordLimit,
		int aWordDelta = DefaultWordDelta);
	virtual ~CQuery();

	short Add(const DString &QWord);
		// returns 0 OK, 1 word already exists
	int Del(int MajorIndex);
          // returns 0 OK, 1 index out of bounds

	int GetWordCount();

	DString GetWord(int MajorIndex, int MinorIndex);

	int AxePunct(CPunctAxe &PunctAxe);
		// returns 0 OK, 1 some words were changed, 2 some
		// words were deleted

	void VariateCase(CAbstractCase *AbstractCase);

     int Stem(CAbstractStemmer *Stemmer);
          // returns 0 OK, 1 some words were changed

private:
	int AxePunctVar(DIArray<DString> *Var,
		CPunctAxe &PunctAxe);

	DIArray<DString> *NewVariate(DIArray<DString> *OldVarIn,
		CAbstractCase *AbstractCase);

	void MatrixAdd(DIArray<DString> *VarIn);
   void MatrixDetach(int Index);
};

#endif

