#include "myfndt.h"
#include "queryopt.h"
#include "oquery.h"
#include "osoftop.h"

CQueryOptions::CQueryOptions()
{
	CStringListValue SoftOps(5, 5);
	Add(O_SOFTOPS, SoftOps);

	WatchSection("OPERATORS");
}

char *CQueryOptions::Init(const char *FName,
	int &Line)
{
	char *err1 = OverrideOptions(this, FName, Line);
	if (err1)
		return err1;

	CStringListValue SoftOps = COptions<CStringListValue>::Get(O_SOFTOPS);
	int Count = SoftOps.GetCount();
	for (int i  = 0; i < Count; i++)
		InitSection(SoftOps[i]);

	ComposedKeys = 1;

	char *err2 = OverrideOptions(this, FName, Line);
	if (err2)
		return err2;

	return NULL;
}

// could use defaults from CGrazerOptions instead of 
// hardcoded values
void CQueryOptions::InitSection(const DString &Section)
{	static const char *Metric[] = {O_FOCUSWEIGHT,
		O_CORRELATIONWEIGHT,
		O_PROMINENCEWEIGHT,
		O_LOCALITYWEIGHT,
		O_ORDERWEIGHT};

	int MetricCount = sizeof(Metric) / sizeof(Metric[0]);
	for (int i = 0; i < MetricCount; i++)
	{	DString KeyStr = GetComposedKey(Section.c_str(), Metric[i]);
		double Weight = 1 / (double)MetricCount;
		Add(KeyStr.c_str(), Weight);
	}

	DString Thre = GetComposedKey(Section.c_str(), O_RELEVANCETHRESHOLD);
	double Shold = 0.5;
	Add(Thre.c_str(), Shold);
}

