#include "myfndt.h"
#include "relans.h"
#include "relevanc.h"

CRelAnswer::CRelAnswer(CStorage *aStorage,
	long aTicket):
	CAnswer(aStorage,
		aTicket,
		sizeof(short) + CRelevance::FeatureCount * sizeof(double)),
	Relevance(NULL)
{  short HasRelevance;

	if (aTicket == 0)
		return;

	CConductor &Conductor = GetConductor();
	Conductor.Get(aTicket, 0, &HasRelevance, sizeof(short));
	if (HasRelevance)
		Relevance = new CRelevance(Conductor,
			aTicket,
			sizeof(short));
}

CRelAnswer::~CRelAnswer()
{
	delete Relevance;
}

void CRelAnswer::SetRelevance(CRelevance *aRelevance)
{
	delete Relevance;
	Relevance = aRelevance;
}

CRelevance *CRelAnswer::GetRelevance()
{
	return Relevance;
}

int CRelAnswer::IsDirty()
{
	return CAnswer::IsDirty() || Relevance != NULL;
}

void CRelAnswer::Store()
{  short HasRelevance;

	CAnswer::Store();
	CConductor &Conductor = GetConductor();
	long Ticket = GetTicket();

	if (Relevance == NULL)
	{	HasRelevance = 0;
		Conductor.Put(Ticket, 0, &HasRelevance, sizeof(short));
		CMemPtr<double> Zero(CRelevance::FeatureCount * sizeof(double));
		for (int i = 0; i < CRelevance::FeatureCount; i++)
			*(((double *)Zero) + i) = 0;
		Conductor.Put(Ticket,
			sizeof(short),
			(double *)Zero,
			CRelevance::FeatureCount * sizeof(double));
	}
	else
	{	HasRelevance = 1;
		Conductor.Put(Ticket, 0, &HasRelevance, sizeof(short));
		const double *MetricList = Relevance->GetMetricList();
		Conductor.Put(Ticket,
			sizeof(short),
			MetricList,
			CRelevance::FeatureCount * sizeof(double));
	}
}
