#include "myfndt.h"
#include "relevanc.h"

const int CRelevance::FeatureCount = 5;
const char *CRelevance::FeatureName[] = {"Focus",
	"Correlation",
	"Prominence",
	"Locality",
	"Order"
};

CRelevance::CRelevance(double aFocusMetric,
	double aCorrelationMetric,
	double aProminenceMetric,
	double aLocalityMetric,
	double aOrderMetric)
{
	MetricList = (double *)malloc(FeatureCount * sizeof(double));
	if (!MetricList)
		throw DMemoryException(FeatureCount * sizeof(double));
	MetricList[Focus] = aFocusMetric;
	MetricList[Correlation] = aCorrelationMetric;
	MetricList[Prominence] = aProminenceMetric;
	MetricList[Locality] = aLocalityMetric;
	MetricList[Order] = aOrderMetric;
}

CRelevance::CRelevance(CConductor &Conductor,
	long Ticket,
	long From)
{
	MetricList = (double *)malloc(FeatureCount * sizeof(double));
	if (!MetricList)
		throw DMemoryException(FeatureCount * sizeof(double));
	Conductor.Get(Ticket,
		From,
		MetricList,
		FeatureCount * sizeof(double));
}

CRelevance::~CRelevance()
{
	free(MetricList);
}

double CRelevance::GetMetric(CRelevance::EFeature Feature)
{
	return MetricList[Feature];
}

