#if !defined(__result_h)
#define __result_h

#include "mconduct.h"

#include "arrays.h"

class DDocument;
class CRelevance;

class CResult
{
private:
	CKeyHandler *KeyHandlerAlias; // must be declared before Storage
	CStorage Storage;
	long DocLimit; // zero => no limit
	long CurrentTotal;

	DISArray<DString> Unknown;

public:
	CResult(const DString &aKeyFilePath,
		const DString &aFreeListFilePath,
		const DString &aDataFilePath,
		long aDocLimit);
	virtual ~CResult();

	void Add(DDocument *Doc,
		double RelRes,
		CRelevance *InRelevance);
		// takes ownership of InRelevance (can be NULL)
		// if there would be more than DocLimit documents,
		// one with the lowest relevance is discarded

	DDocument *NewFirstDoc();
	DDocument *NewNextDoc(DDocument *Doc);

	void SetUnknown(DISArray<DString> &aUnknown);
	DISArray<DString> &GetUnknown() { return Unknown; }

private:
	long ConvertRelevance(double Relevance);
};

#endif

