#if !defined(__term_h)
#define __term_h

#include "subform.h"
#include "options.h"

class CGrazerOptions;
class CQuery;
class CQueryBuilder;
class CSoftOperator;
class CWordMask;

class CTerm : public CSubFormula
{
public:
    typedef void (*FPrint)(const char *);

    CTerm(int Count,
        char *Arg[],
	   FPrint Print, 
	   CGrazerOptions &Options);
    CTerm(CQueryBuilder &QueryBuilder);
    virtual ~CTerm();

    virtual int Collate(CFrontLine &FrontLine);
        // returns 0 OK, 1 interrupted
    virtual void AddRelevant(CResult *Result, CDocWrapper *DocWrapper);
    virtual int IsRelevant(CDocWrapper *DocWrapper, double &Relevance);

private:
    // pointers leak memory when throwing exceptions!
    CQuery *Query;
    CSoftOperator *SoftOperator; 

    CWordMask *Mask;

    DISArray<DString> DuplWords;
    int PunctChange;

    void FillQuery(int Count, char *Arg[]);
    void ExpandQuery(CGrazerOptions &Options);
    void FinalDuplCheck();

    void AddDupl(const DString &DWord);

    int FillFrontLine(CFrontLine &FrontLine, short Base);

    void PrintWarnings(FPrint Print, CGrazerOptions &Options);
    void DisplayWords(FPrint Print, CGrazerOptions &Options);
};

#endif
