#if !defined(__wordmask_h)
#define __wordmask_h

class CWordMask
{
public:
    inline CWordMask(ushort aMin, ushort aMax);

    inline int Has(ushort Index) const;
    inline ushort Constrict(ushort Index) const;
        // maps active indices onto interval

    inline int GetCount() const;

private:
    ushort Min;
    ushort Max;
};

inline CWordMask::CWordMask(ushort aMin, ushort aMax):
    Min(aMin), Max(aMax)
{
    Assert(Min <= Max);
}

inline int CWordMask::Has(ushort Index) const
{
    return Min <= Index && Index <= Max;
}

inline ushort CWordMask::Constrict(ushort Index) const
{
    Assert(Has(Index));
    return Index - Min;
}

inline int CWordMask::GetCount() const
{
    return Max - Min + 1;
}

#endif
