#if !defined(__dpairstl_h)
#define __dpairstl_h

#if defined(EXTERNAL_TEMPLATES)
#pragma interface
#endif

#include <map.h>
#include <function.h>

template<class CKey, class CValue>
class DPair : public	map<CKey, CValue, less<CKey> >::value_type
{
public:
	typedef map<CKey, CValue, less<CKey> >::iterator CValuePtr;

	static int Dereferenceable(CValuePtr Ptr)
		{	return !(Ptr == end()); }
	static CValue &GetValue(CValuePtr Ptr)
		{	Assert(Dereferenceable(Ptr)); return (*Ptr).second; }

public:
	DPair() { }
	DPair(const CKey &Key, const CValue &Value):
		map<CKey, CValue, less<CKey> >::value_type(Key, Value) { }
};

#endif
