#if !defined(__isarrayb_h)
#define __isarrayb_h

#if defined(EXTERNAL_TEMPLATES)
#pragma interface
#endif

template <class DItem>
class DISArray : public TISArrayAsVector<DItem>
{
public:
	typedef TISArrayAsVectorIterator<DItem> DIterator;

private:
// not implemented
	operator == (const DISArray<DItem> &) const;
	operator != (const DISArray<DItem> &) const;
	operator < (const DISArray<DItem> &) const;
	DISArray(const DISArray<DItem> &Other);

public:
	DISArray(int aLimit, int aDelta):
		TISArrayAsVector<DItem>(aLimit - 1, 0, aDelta) { }
	virtual ~DISArray() { }

	inline int GetCount() const
		{ return GetItemsInContainer(); }

	inline DIterator InitIterator() const
		{ return DIterator(*this); }
	inline int IsDereferenceable(DIterator &Itr) const
		{ return Itr != NULL; }

	inline void Add(DItem *Item);
	void DetachByIndex(int Index)
		{ Detach(Index); }

	static DItem *GetCurrent(DIterator &Itr)
		{ return Itr.Current(); }
};

template <class DItem>
void DISArray<DItem>::Add(DItem *Item)
{
	if (!TISArrayAsVector<DItem>::Add(Item))
		throw DMemoryException();
}

#endif

