#if !defined(__sarrayb_h)
#define __sarrayb_h

#if defined(EXTERNAL_TEMPLATES)
#pragma interface
#endif

template <class DItem>
class DSArray : public TSArrayAsVector<DItem>
{
public:
	typedef TSArrayAsVectorIterator<DItem> DIterator;

private:
// not implemented
	operator == (const DSArray<DItem> &) const;
	operator != (const DSArray<DItem> &) const;
	operator < (const DSArray<DItem> &) const;
	DSArray<DItem> & operator = (const DSArray<DItem> &);

public:
	DSArray(int aLimit, int aDelta):
		TSArrayAsVector<DItem>(aLimit - 1, 0, aDelta) { }
	DSArray(const DSArray<DItem> &Other);
	virtual ~DSArray() { }

	inline int GetCount() const
		{ return GetItemsInContainer(); }

	inline DIterator InitIterator() const
		{ return DIterator(*this); }
	inline int IsDereferenceable(DIterator &Itr) const
		{ return Itr != NULL; }

	inline void Add(const DItem &Item);
	void DetachByIndex(int Index)
		{ Detach(Index); }

	static DItem GetCurrent(DIterator &Itr)
		{ return Itr.Current(); }
};

template <class DItem>
DSArray<DItem>::DSArray(const DSArray<DItem> &Other):
	TSArrayAsVector<DItem>(Other.ArraySize() - 1,
		0,
		Other.Data.GetDelta())
{
	DIterator Itr = Other.InitIterator();
	while (Other.IsDereferenceable(Itr))
	{	Add(Itr.Current());
		++Itr;
	}
}

template <class DItem>
void DSArray<DItem>::Add(const DItem &Item)
{
	if (!TSArrayAsVector<DItem>::Add(Item))
		throw DMemoryException();
}

#endif

