#include "myfndt.h"
#include "assoc.h"
#include "datum.h"

CAssoc::CAssoc(CKeyHandler *aHandler,
	KEY aKey,
	CDatum *aDatum):
	Handler(aHandler),
	Key(aHandler->NewCopy(aKey)),
	Datum(aDatum),
	LockCount(0)
{
}

CAssoc::~CAssoc()
{
	delete Datum;
	CKeyHandler::DelKey(Key);
}

#if defined(NOCPCONSTRUCT)
int CAssoc::operator == (const CAssoc *Other)
{
	return !Handler->Compare(Key, Other->Key);
}

int CAssoc::operator < (const CAssoc *Other)
{
	return Handler->Compare(Key, Other->Key) < 0;
}

int CAssoc::operator > (const CAssoc *Other)
{
	return Handler->Compare(Key, Other->Key) > 0;
}
#endif

