#if !defined(__assoc_h)
#define __assoc_h

#include "tl.h"

class CDatum;

class CAssoc
{
protected:
	CKeyHandler *Handler;
	KEY Key;
	CDatum *Datum;

private:
	ushort LockCount;

public:
	CAssoc(CKeyHandler *aHandler, KEY aKey, CDatum *aDatum);
		// takes ownership of aDatum
	virtual ~CAssoc();

	KEY GetKey() const { return Key; }
	CDatum *GetDatum() const { return Datum; }

	void IncLockCount() { LockCount++; }
	int DecLockCount() { return !(--LockCount); }

#if defined(NOCPCONSTRUCT)
	int operator == (const CAssoc *Other);
	int operator < (const CAssoc *Other);
	int operator > (const CAssoc *Other);
#else
	int operator == (const CAssoc &Other) const
		{ return !Handler->Compare(Key, Other.Key); }
	int operator < (const CAssoc &Other) const
		{ return Handler->Compare(Key, Other.Key) < 0; }
#endif
};

#endif

