#include "myfndt.h"
#include "datum.h"
#include "mconduct.h"
#include "storag.h"

CDatum::CDatum(CStorage *aStorage, long aTicket):
	Storage(aStorage),
	Ticket(aTicket),
	Count(1)
{
}

CDatum::~CDatum()
{
}

void CDatum::Remove()
{
	if (Ticket != 0)
	{	CConductor &Conductor = GetConductor();
		Conductor.Del(Ticket);
		Ticket = 0;
	}
}

CConductor &CDatum::GetConductor()
{
	return Storage->GetConductor();
}

CDatumEnvelope::CDatumEnvelope(CDatum *aDatum):
	Datum(aDatum)
{
     if (Datum)
     	Datum->Count = 1;
}

CDatumEnvelope::CDatumEnvelope(const CDatumEnvelope &Src):
	Datum(Src.Datum)
{
     if (Datum)
	     Datum->Count++;
}

CDatumEnvelope::~CDatumEnvelope()
{
	if (Datum && (--Datum->Count <= 0))
		Datum->Storage->Unlock(Datum);
}

CDatumEnvelope &CDatumEnvelope::operator = (const CDatumEnvelope &Src)
{
	CDatum *SrcDatum = Src.Datum;
	if (SrcDatum)
		SrcDatum->Count++;
	if (Datum && (--Datum->Count <= 0))
		Datum->Storage->Unlock(Datum);
	Datum = SrcDatum;
	return *this;
}

