#include "myfndt.h"
#include "dualassc.h"

CDualAssoc::CDualAssoc(DString &ConListName, DString &ConDataName,
		DString &NumName, DString &StrName, ushort AveStrLen,
		ushort Opt):
	NumToStr(new CULongHandler(), NumName, Opt),
	StrToNum(new CCompressedStrHandler(AveStrLen), StrName, Opt),
	Conductor(ConListName, ConDataName, Opt)
{
}

CDualAssoc::~CDualAssoc()
{
}

short CDualAssoc::Add(ulong Num, const DString &Str)
{	LONG Data;
	short KnownRet;

	// check duplicities
	short RetVal = 0;

	CNewKey NumKey(CULongHandler::NewKey(Num));
	if (!NumToStr.GetData(NumKey, Data))
		RetVal |= 1;

	CNewKey StrKey(CCompressedStrHandler::NewKey(Str.c_str()));
	if (!StrToNum.GetData(StrKey, Data))
		RetVal |= 2;

	if (RetVal)
		return RetVal;

	// add
	short Len = (short)(Str.GetLength() + 1);
	long Ticket = Conductor.Add(Len);
	Conductor.Put(Ticket, 0, Str.c_str(), Len);
	KnownRet = NumToStr.Add(NumKey, Ticket);
	Assert(KnownRet == 0);

	KnownRet = StrToNum.Add(StrKey, Num);
	Assert(KnownRet == 0);

	return 0;
}

short CDualAssoc::Del(ulong Num)
{	long Ticket;
	short KnownRet;

	CNewKey NumKey(CULongHandler::NewKey(Num));
	if (NumToStr.GetData(NumKey, Ticket))
		 return 1;

	CMemPtr<char> Str = static_cast<char *>(Conductor.Alloc(Ticket));
	CNewKey StrKey(CCompressedStrHandler::NewKey((char *)Str));
	KnownRet = StrToNum.Del(StrKey);
	Assert(KnownRet == 0);
	Conductor.Del(Ticket);

	KnownRet = NumToStr.Del(NumKey);
	Assert(KnownRet == 0);

	return 0;
}

short CDualAssoc::Del(const DString &Str)
{	LONG Data;
	long Ticket;
	short KnownRet;

	CNewKey StrKey(CCompressedStrHandler::NewKey(Str.c_str()));
	if (StrToNum.GetData(StrKey, Data))
		return 1;

	ulong Num = Data;
	StrToNum.Del(StrKey);

	CNewKey NumKey(CULongHandler::NewKey(Num));
	KnownRet = NumToStr.GetData(NumKey, Ticket);
	Assert(KnownRet == 0);
	Conductor.Del(Ticket);

	KnownRet = NumToStr.Del(NumKey);
	Assert(KnownRet == 0);

	return 0;
}

short CDualAssoc::Get(ulong Num, DString &Str)
{	long Ticket;

	CNewKey NumKey(CULongHandler::NewKey(Num));
	if (NumToStr.GetData(NumKey, Ticket))
		return 1;

	CMemPtr<char> NewStr = static_cast<char *>(Conductor.
			Alloc(Ticket));
	Str = (char *)NewStr;
	return 0;
}

short CDualAssoc::Get(const DString &Str, ulong &Num)
{	long Data;

	CNewKey StrKey(CCompressedStrHandler::NewKey(Str.c_str()));
	if (StrToNum.GetData(StrKey, Data))
		return 1;
	else
	{	Num = Data;
		return 0;
   }
}


