#if !defined(__dualassc_h)
#define __dualassc_h

#include "tl.h"
#include "conduct.h"

class CDualAssoc
{
private:
	CBook NumToStr;
	CBook StrToNum;
	CConductor Conductor;

public:
	CDualAssoc(DString &ConListName, DString &ConDataName,
			DString &NumName, DString &StrName, ushort AveStrLen,
			ushort Opt);
	virtual ~CDualAssoc();

	short Add(ulong Num, const DString &Str);
		// returns 0 OK, 1 Num already exists, 2 Str already
		// exists, 3 Num and Str already exist

	short Del(ulong Num);
		// returns 0 OK, 1 Num does not exist

	short Del(const DString &Str);
		// returns 0 OK, 1 Str does not exist

	short Get(ulong Num, DString &Str);
		// Str is out param
		// returns 0 OK, 1 Num does not exist

	short Get(const DString &Str, ulong &Num);
		// Num is out param
		// returns 0 OK, 1 Str does not exist

	void StoreAll()
		{ NumToStr.StoreAll(); StrToNum.StoreAll(); Conductor.StoreAll(); }
};

#endif

