#include "myfndt.h"
#include "htwolong.h"

#include <string.h>

struct STwoLong
{	long HighLong;
	long LowLong;
};

KEY CTwoLongHandler::NewKey(long HighLong, long LowLong)
{	STwoLong TwoLong;

	TwoLong.HighLong = HighLong;
	TwoLong.LowLong = LowLong;
	KEY ret = CKeyHandler::NewKey(sizeof(STwoLong));
	memcpy(ret, &TwoLong, sizeof(STwoLong));
	return ret;
}

void CTwoLongHandler::GetTwoLong(KEY Key, long &HighLong, long &LowLong)
{
	STwoLong *TwoLong = reinterpret_cast<STwoLong *>(Key);
	HighLong = TwoLong->HighLong;
	LowLong = TwoLong->LowLong;
}

KEY CTwoLongHandler::NewCopy(KEY Key)
{
	KEY ret = CKeyHandler::NewKey(sizeof(STwoLong));
	memcpy(ret, Key, sizeof(STwoLong));
	return ret;
}

KEY CTwoLongHandler::Load(KEY, CFileObj *Stream)
{
	KEY Key = CKeyHandler::NewKey(sizeof(STwoLong));
	Stream->Read(Key, sizeof(STwoLong));
	return Key;
}

void CTwoLongHandler::Save(KEY, KEY Key, CFileObj *Stream)
{
	Stream->Write(Key, sizeof(STwoLong));
}

ushort CTwoLongHandler::GetDiskLen(KEY, KEY)
{
	return sizeof(STwoLong);
}

ushort CTwoLongHandler::GetAveDiskLen()
{
	return sizeof(STwoLong);
}

ushort CTwoLongHandler::GetAveKeyLen()
{
	return sizeof(STwoLong);
}

short CTwoLongHandler::Compare(KEY Key1, KEY Key2)
{
	STwoLong *TwoLong1 = reinterpret_cast<STwoLong *>(Key1);
	STwoLong *TwoLong2 = reinterpret_cast<STwoLong *>(Key2);

	long c = TwoLong1->HighLong - TwoLong2->HighLong;
	if (c)
		return (short)(c < 0 ? -1 : 1);
	c = TwoLong1->LowLong - TwoLong2->LowLong;
	if (c)
		return (short)(c < 0 ? -1 : 1);
	return 0;
}

