#if !defined(__remtab_h)
#define __remtab_h

#include "arrays.h"
#include "assoc.h"
#include "invertas.h"
#include "tl.h"

class CStorage;

class CRemTable
{
// types & const params
public:
	static const int DefaultLimit;
	static const int DefaultDelta;

// members
private:
	DISArray<CAssoc> Table;
	DISArray<CInvertedAssoc> InvertedTable;
	CKeyHandler *KeyHandlerAlias;

public:
	CRemTable(int Limit,
		int Delta,
		CKeyHandler *aKeyHandlerAlias);
	virtual ~CRemTable();

	CAssoc *Get(KEY Key);
	CAssoc *Get(CDatum *Datum);

	void Add(CAssoc *Assoc);
	void Detach(CAssoc *Assoc);

	void StoreAll(CStorage *Storage);

	KEY GetFirstKey();
	KEY GetLastKey();
	KEY GetNextKey(KEY Key);
	KEY GetKeyAfter(KEY Key);

	int IsEmpty();

private:
	CInvertedAssoc *GetInverted(CDatum *Datum);
	int GetTableIndex(KEY Key);
};

#endif

