#if !defined(__actfile_h)
#define __actfile_h

class CArchiverCommand;

class CActiveFile
{
private:
	DString StoredName;
	DString ContentName;
	int RefCount;

public:
	CActiveFile(CArchiverCommand &aArchiverCommand,
		const DString &aStoredName,
		const DString &aContentDir);
	CActiveFile(const DString &aStoredName);
	~CActiveFile();

	DString GetContentName() { return ContentName; }

	void IncRefCount() { RefCount++; }
	int DecRefCount();

#if defined(NOCPCONSTRUCT)
	operator == (const CActiveFile *Other) const
		{ return StoredName == Other->StoredName; }
	operator < (const CActiveFile *Other) const
		{ return StoredName < Other->StoredName; }
	operator > (const CActiveFile *Other) const
		{ return StoredName > Other->StoredName; }
#else
	operator == (const CActiveFile &Other) const
		{ return StoredName == Other.StoredName; }
	operator < (const CActiveFile &Other) const
		{ return StoredName < Other.StoredName; }
#endif

private:
	static void RunArchiver(const DString &CommandLine);
	static DString LocateFile(const DString &aContentDir,
		const DString &Mask);
	static DString GetMask(const DString &aStoredName);
};

#endif

