#if !defined(__archcmd_h)
#define __archcmd_h

class CArchiverCommand
{
public:
	CArchiverCommand(const DString &aCommand,
		const DString &NameMask,
		const DString &DirMask);

	DString Parse(const DString &StoredName,
		const DString &ContentDir);
	int IsWellFormed();

private:
	enum EType { tInvalid, tNoPar, tStr_Name, tName, tStr_Dir,
			tDir, tStr_Name_Dir, tName_Dir, tStr_Dir_Name,
			tDir_Name };

	DString Part0;
	DString Part1;
	DString Part2;
	EType Type;
		// <0 invalid, 0 no params, 1 StoredName, 2 ContentDir,
		// 3 StoredName ContentDir, 4 ContentDir StoredName

	void SetTypeNoPar(const DString &aCommand);
	void SetSimpleType(EType aType,
		const DString &aCommand,
		int Offs,
		int Len);
	void SetFullType(const DString &aCommand,
		int NameOffs,
		int NameLen,
		int DirOffs,
		int DirLen);
	void SetFullTypeSorted(EType aType,
		const DString &aCommand,
		int FirstOffs,
		int FirstLen,
		int SecondOffs,
		int SecondLen);

	DString ComposeTypeNoPar();
	DString ComposeSimpleType(const DString &InsertStr,
		int StartFixed);
	DString ComposeFullTypeSorted(const DString &FirstInsertStr,
		const DString &SecondInsertStr,
		int StartFixed);
};

#endif

