#if !defined(__buildp_h)
#define __buildp_h

#include "occdatum.h"
#include <vector.h>

class CPacker;

class COccBuilder : public COccDatum
{
// consts & types
private:
    static const int MarginThreshold;
    static const int AQuotient;
    static const double BQuotient;
    static const int SettledThreshold;
    static const int MaxBlockCount;

private:
    static CPacker Packer;

public:
    COccBuilder(CStorage *aStorage, long aTicket);
    virtual ~COccBuilder();

    virtual long Finish();

    void Add(const vector<ulong> &Occs);

private:
    // these functions modify their input!
    void AddBlock(ulong *OccArray, int Count);
    long AddNew(ulong *OccArray, int Count);
    long AddEx(ulong *OccArray, int Count);

    long AddNewTicket(ulong *Occ1,
	int Count1,
	ulong *Occ2,
	int Count2);
    long AddOnTip(long OldTicket,
	long OldCount,
	ulong *OccArray,
	int Count);
    long AddBig(long OldTicket,
	long OldCount,
	ulong *OccArray,
	int Count);
    void BuildSecond(long OldTicket,
	long OldCount,
	ulong *OccArray,
	int Count);

	void BuildSegmented(long OldTicket,
		long OldCount,
		ulong *OccArray,
		int Count);
	void BuildExSegment(STail &Tail, // in & out param
		long TipCount,
		ulong *OccArray,
		int Count);
	void BuildNewSegment(STail &Tail, // in & out param
		ulong *OccArray,
		int Count);
	ulong GetOldTipMoved(long OldTipTicket);
	void SetOldInnerLastNext(long InnerLastTicket,
		long NextTicket);

	long RoundMargin(long Size, long OldMargin);

	long MakeRoom(long CurTicket,
		long CurCount,
		ulong *DestBuf,
			// out: occurences from the end of CurTicket
		int &DestBufCount,
			// in: DestBuf size (in sizeof(ulong))
			// out: number of occurences filled
		ulong *&SrcPadding,
			// in: occurences to add
			// out: occurences which were not added
		int &SrcPaddingCount);
			// in & out: number of items of SrcPadding
		// when using up all padding, updates count on disk
		// returns count in first segment
};

#endif

