#include "myfndt.h"
#include "change.h"

CChange::CChange():
    ValidSize(-1),
    ChunkFrom(-1),
    ChunkTo(-1),
    Stack(2, 10)
{
}

void CChange::Reset()
{
    ValidSize = 0;
    Stack.erase(Stack.begin(), Stack.end());
    ChunkFrom = ChunkTo = -1;
}

int CChange::IsAfterSign(int Pos) 
{ 
    if (ChunkFrom == -1)
        return 0;
    return Pos >= ChunkFrom; 
}

int CChange::GetPosAfterSign()
{
    if (ChunkTo == -1)
        return 0;
    return ChunkTo + 1;
}

short CChange::GetChangedSubdoc()
{
    int Count = Stack.GetCount();
    if (!Count)
        return 0;
    else 
        return Stack[Count - 1];
}

void CChange::ClearSign()
{
    ChunkFrom = ChunkTo = -1;
}

void CChange::SetSign(int From, int To)
{
    ChunkFrom = From;
    ChunkTo = To;
}

