#include "myfndt.h"
#include "ddkey.h"
#include "dualmap.h"

CDocDescKey::CDocDescKey(const CDocDesc &DocDesc,
	CDualMap *DualMap):
	CDocDescBase(DocDesc)
{
#if defined(DEBUG_cut_exception)
    printf("CDocDescKey::CDocDescKey: 1\n");
#endif
	if (!DualMap->Get(DocDesc.Str, RegId))
		return;

#if defined(DEBUG_cut_exception)
    printf("CDocDescKey::CDocDescKey: 2\n");
#endif
	if (!DualMap->GetMax(RegId))
		RegId++;
	else
		RegId = 0;

#if defined(DEBUG_cut_exception)
    printf("CDocDescKey::CDocDescKey: adding %s\n", DocDesc.Str.c_str());
#endif
	short KnownRet = DualMap->Add(RegId, DocDesc.Str);
	Assert(!KnownRet);
}

CDocDescKey::CDocDescKey(KEY Key)
{
	char *p = (char *)Key;
	memcpy(&StartOffs, p, sizeof(long));
	p += sizeof(long);
	memcpy(&RegId, p, sizeof(long));
}

CDocDescKey::~CDocDescKey()
{
}

void CDocDescKey::FillKey(KEY RawKey)
{
	char *p = (char *)RawKey;
	memcpy(p, &StartOffs, sizeof(long));
	p += sizeof(long);
	memcpy(p, &RegId, sizeof(long));
}

void CDocDescKey::FillDocDesc(CDualMap *DualMap,
	CDocDesc &DocDesc)
{
	DocDesc.StartOffs = StartOffs;
	short KnownRet = DualMap->Get(RegId, DocDesc.Str);
	Assert(!KnownRet);
}

short CDocDescKey::Compare(const CDocDescKey &Other)
{
	if (RegId != Other.RegId)
		return (short)(RegId > Other.RegId ? 1 : -1);
	return CDocDescBase::Compare(Other);
}

