#if !defined(__decompr_h)
#define __decompr_h

#include "actfile.h"
#include "archcmd.h"
#include "arrays.h"

class CLocusOptions;

// ExeDrive could be in separate class since cruncher does not need it
class CDecompressor
{
private:
	static int ActiveFileLimit;
	static int ActiveFileDelta;
public:
	CDecompressor(CLocusOptions &Options,
		int aActiveFileLimit = ActiveFileLimit,
		int aActiveFileDelta = ActiveFileDelta);
	~CDecompressor();

	DString GrabContentFile(const DString &StoredFileName);
	void DropContentFile(const DString &StoredFileName);
	void DropAll();

private:
    const DString ExeDrive;
    const DString ExeDriveName;
	const DString CompressedExt;
	const DString ContentDir;
	CArchiverCommand ArchiverCommand;
	DISArray<CActiveFile> ActiveFiles;

    DString Decompress(const DString &StoredFileName);
	static int MatchExt(const DString &FName, const DString &Ext);
};

#endif


