#if !defined(__dircont_h)
#define __dircont_h

#include "lversion.h"

#if defined(__GNUG__)
#include <dirent.h>
#else
#if !defined(PLATFORM_WIN32)
struct ffblk;
#endif
#endif

class CDirectory
{
public:
	static const char PathBreak;
	static const char *PathBreakStr;

public:
	CDirectory(const DString &aDirName, const DString &aMask);
	virtual ~CDirectory();
	DString ReadNext();
		// returns empty string => no more files

	enum EType {nomore, file, dir};
     EType NextFileOrDir(DString &Name);

     static DString GetPathName(const DString &Path, const char *Name);

private:
	DString DirName;
#if defined(__GNUG__)
	DIR *Directory;
	DString Mask;
#else
#if defined(PLATFORM_WIN32)
	WIN32_FIND_DATA *FileFindData;
	HANDLE FFHandle;
#else
	struct ffblk *FileFindData;
#endif
	DString NextFile;
#endif

	DString GetNextFile();
#if defined(__GNUG__)
	int IsMatch(const char *Name);
#endif

    EType GetNextFile2(DString &Name);
#if defined(__GNUG__)
    EType IsMatch2(const char *Name);
#endif
};

#endif

