#if !defined(__docdesc_h)
#define __docdesc_h

class CDocDescKey;
class CDecompressor;

class CDocDescBase
{
protected:
	long StartOffs;

	CDocDescBase(long aStartOffs);
	CDocDescBase(const CDocDescBase &Other);
	CDocDescBase();
	~CDocDescBase();

	short Compare(const CDocDescBase &Other);

public:
	long GetStartOffs() const { return StartOffs; }
};

class CDocDesc : public CDocDescBase
{
friend class CDocDescKey;
private:
	DString Str;

public:
	CDocDesc(const DString &aStr,	long aStartOffs);
	CDocDesc();
	~CDocDesc();

	static ushort GetDiskLen() { return sizeof(long) + sizeof(long); }
	const DString &GetFileName() const { return Str; }
	void SetContentFile(CDecompressor *Decompressor);
};

#endif
