#include "myfndt.h"
#include "docsrc.h"

CDocSource::CDocSource(const DString &aEndMark, int aChunkSize):
    EndMark(aEndMark),
    ChunkSize(aChunkSize),
    CurFileName(""),
    CurOffs(0),
    Buf(NULL),
    ValidBufSize(0),
    Pos(-1)
{
}

CDocSource::~CDocSource()
{
}

void CDocSource::SetIn(const DString &FName, long NewOffs)
{
    CurFileName = FName;
    CurOffs = NewOffs;
    ValidBufSize = 0;

    CFileObj Source(FName.c_str(), "rb");
    Source.Seek(0, SEEK_END);
    long MaxSize = Source.Tell();
    Assert(MaxSize >= NewOffs);
    MaxSize -= NewOffs;
    Source.Seek(NewOffs);

    while (!ReadStep(Source, MaxSize))
    {   if (FoundEnd())
	    return;
    }
    FoundEnd();
}

int CDocSource::ReadStep(CFileObj &Source, int MaxSize)
{
    if (!ValidBufSize)

void CDocSource::Seek(long NewOffs)
{
    SetIn(CurFileName, NewOffs);
}

short CDocSource::GetPerc()
{
    if (!ValidBufSize || Pos < 0)
	return 0;
    return (short)((100 * Pos) / ValidBufSize);
}

short CDocSource::GetChar(char &c)
{
    if (Pos >= ValidBufSize)
	return 1;

    c = *(((char *)Buf) + Pos++);
    return 0;
}

long GetOffs()
{
    Assert(Pos > 0);
    return CurOffs + Pos - 1;
}

private:
    DString CurFileName;
    CSmartPtr<char> Buf;
    int ValidBufSize;
    int Offs;
};

#endif
