#if !defined(__docsrc_h)
#define __docsrc_h

class CDocSource
{
public:
    CDocSource(const DString &aEndMark, int aChunkSize);
    virtual ~CDocSource();

    void SetIn(const DString &FName, long NewOffs = 0);
    void Seek(long NewOffs);

    short GetPerc();
    short GetChar(char &c);
	  // returns 0 OK, 1 EOF

    // returns offset of the last character requested by GetChar
    // asserts GetChar was already called and returned valid char
    long GetOffs();

private:
    DString EndMark;
    const int ChunkSize;
    DString CurFileName;
    long CurOffs;
    CSmartPtr<char> Buf;
    short ValidBufSize;
    short Pos;

    int ReadStep(CFileObj &Source, long MaxSize);
};

#endif
