#if !defined(__dualmap_h)
#define __dualmap_h

#include "tl.h"
#include "mconduct.h"

class CDualMap : public CBook
    // the ancestor is a list of document files (was StrToNum)
{
private:
	CBook NumToStr;
	CConductor Conductor;

public:
	CDualMap(ushort Opt,
		ushort AveStrLen,
		const DString &NumTreeName,
		const DString &StrTreeName,
		const DString &ConductListName,
		const DString &ConductDataName);
	virtual ~CDualMap();

	short Add(ulong Num, const DString &Str);
		// returns 0 OK, 1 Num already exists, 2 Str
		// already exists, 3 Num and Str already exist

	short Del(ulong Num);
		// returns 0 OK, 1 Num does not exist

	short Del(const DString &Str);
		// returns 0 OK, 1 Str does not exist

	short Get(ulong Num, DString &Str);
		// Str is out param
		// returns 0 OK, 1 Num does not exist

	short Get(const DString &Str, ulong &Num);
		// Num is out param
		// returns 0 OK, 1 Str does not exist

	void StoreAll()
		{ NumToStr.StoreAll(); CBook::StoreAll(); Conductor.StoreAll(); }

	int Has(const DString &Str);

	short GetMax(ulong &Num);
		// return 0 OK, 1 is empty
};

#endif

