#include "myfndt.h"
#include "lversion.h"
#include "exedrive.h"

#include <string.h>

DString GetExeDrive(const char *Arg)
{
#if !defined(PLATFORM_DOS) && !defined(PLATFORM_WIN32)
     return DString("");
#else
	Assert(Arg != NULL && strlen(Arg) > 3 &&
		Arg[1] == ':');
#if !defined(__DJGPP__)
	Assert(Arg[2] == '\\');  
#else
	Assert(Arg[2] == '/');  
#endif
	DString ExeDrive;
	ExeDrive += Arg[0];
	ExeDrive += ":\\";
	return ExeDrive;
#endif
}

DString GetLocalName(const DString &GlobalExeDrive,
	const DString &LocalExeDrive,
	const DString &GlobalName)
{
	if (GlobalExeDrive.IsEmpty() || LocalExeDrive.IsEmpty())
		return GlobalName;

    int Len = GlobalExeDrive.GetLength();
	if (GlobalName.GetLength() <= Len ||
		strncmp(GlobalExeDrive.c_str(), GlobalName.c_str(), Len))
			// always case-sensitive - even for DOS
		return GlobalName;

	DString LocalName = LocalExeDrive;
	LocalName += GlobalName.c_str() + Len;
	return LocalName;
}

