#if !defined(__fbdual_h)
#define __fbdual_h

#include "tl.h"
#include "mconduct.h"
#include "docdesc.h"

class CLocusOptions;
class CDocHandler;
class CDualMap;

class CFBDual
{
public:
	CFBDual(ushort Opt,
		CLocusOptions &Options);
	virtual ~CFBDual();

	short Add(ulong Num, const CDocDesc &DocDesc);
		// returns 0 OK, 1 Num already exists, 2 DocDesc
		// already exists, 3 Num and DocDesc already exist

	short Del(ulong Num);
		// returns 0 OK, 1 Num does not exist

	short Del(const CDocDesc &DocDesc);
		// returns 0 OK, 1 DocDesc does not exist

	short Get(ulong Num, CDocDesc &DocDesc);
		// DocDesc is out param
		// returns 0 OK, 1 Num does not exist

	short Get(const CDocDesc &DocDesc, ulong &Num);
		// Num is out param
		// returns 0 OK, 1 DocDesc does not exist

	void StoreAll();

	short Has(const DString &DocName);

private:
    CDualMap *DocFilesAlias;
    CDocHandler *DocHandlerAlias;
    CBook *NumToDoc;
    CBook *DocToNum;
    CConductor *Conductor;
};

#endif

