#include "myfndt.h"
#include "filestat.h"

const int CFileBufRead::BufSize = 200;

CFileBufRead::CFileBufRead():
	File(NULL), Size(-1), Pos(-1), Buf(BufSize),
			CurBufSize(0), Offs(0)
{
}

CFileBufRead::~CFileBufRead()
{
}

void CFileBufRead::SetIn(const DString &FName, long NewOffs)
{
	File.Open(FName.c_str(), "rb" /* "r+b" */);
	File.Seek(0, SEEK_END);
	Size = File.Tell();
	Seek(NewOffs);
}

void CFileBufRead::Seek(long NewOffs)
{
	File.Seek(NewOffs, SEEK_SET);
	Pos = NewOffs;

	CurBufSize = Offs = 0;
}

short CFileBufRead::GetChar(char &c)
{
	if (Offs >= CurBufSize)
	{	if (Pos + CurBufSize >= Size)
			return 1;

		Pos += CurBufSize;
		long Delta = Size - Pos;
		CurBufSize = Delta >= BufSize ? BufSize :
				static_cast<int>(Delta);
		File.Read((char *)Buf, CurBufSize);
		Offs = 0;
	}

     c = *((char *)Buf + Offs++);
     if (!c)
	     return 1; // don't read binary files

	return 0;
}

long CFileBufRead::GetOffs()
{
	Assert(CurBufSize && Offs > 0);
	return Pos + Offs - 1;
}

short CFileBufRead::IsSeparator(char C)
{
	return C == ' ' || C == '\n' || C == '\r' || C == '\t';
}

short CFileBufRead::GetPerc()
{
	if (Size <= 0)
		return 100;
	return (short)((100 * (Pos + Offs)) / Size);
}

