#include "myfndt.h"
#include "fillopt.h"
#include "options.h"
#include "watch.h"

#include "ouno.h"
#include "osubdoc.h"

#include <stdio.h>

int FillOptions(CUnivOptions &Options)
{	int line;
//	const char *file = "c:\\users\\jun\\locus\\locus.opt";
		// debugged program cannot find relative path
#if defined(__BORLANDC__)
	const char *file = ".\\locus.opt";
#else
	const char *file = "locus.opt";
#endif

	char *ret = OverrideOptions(&Options, file, line);
	if (ret)
	{	printf("error parsing file %s on line %d: %s\n",
			file,
			line,
			ret);
		return 1;
	}

	DString InvalKey = Options.FirstInvalidKey();
	if (!InvalKey.IsEmpty())
	{	printf("uninitialized key %s\n", InvalKey.c_str());
		return 1;
	}

    return FillUno(Options, O_DOCPARTS, CWatch::SetSubdocClass);
}

int FillUno(CUnivOptions &Options, 
    const char *ListKey,
    FSetUnoClass SetUnoClass)
{
    CStringListValue List = Options.COptions<CStringListValue>::Get(ListKey);
    SetUnoClass(Options, List);

    Options.SetComposedMode(1);
    Options.ChangeWatchedSections(List);

    DString UnoFile = Options.Get(O_UNOFILE);
    Assert(!UnoFile.IsEmpty());

    int Line;
    char *Err = OverrideOptions(&Options, UnoFile.c_str(), Line);
    if (Err)
    {   DString ParseUnoErrFormat = Options.Get(T_PARSEUNOERRFORMAT_SDSN);
        printf(ParseUnoErrFormat.c_str(), UnoFile.c_str(), Line, Err);
        return -1;
    }

    return 0;
}


