#if !defined(__fixedocc_h)
#define __fixedocc_h

#include "occdatum.h"

//#define DEBUG_CFixedOcc

class CFixedOcc : public COccDatum
{
// consts & types
private:
	static const int OutLimit; // used in constructor of COccList
	static const long CompressCacheOnlyIterator;

	class COccList
	{
	public:
		ulong *OccList;
		int ListCount;
		long Delta;

		COccList(CConductor &Conductor,
			long Ticket,
			long aDelta,
			int Count);
		~COccList(); // not virtual
	};

private:
	enum EItrStatus { get_next = 0, use_second = 1 };

// members
private:
	COccList *OutOcc; // mostly null
	long CurrentTicket;
	STail *InternalTail; // initialized lazily by GetTail
	short TailUnknown;

	EItrStatus ItrStatus;
	ulong CurBase;
     ulong LastCompressedOcc;

public:
	CFixedOcc(CStorage *aStorage, long aTicket);
	virtual ~CFixedOcc();

	virtual long Finish();

	long InitIterator();
	ulong GetNext(long &Iterator);

#if defined(DEBUG_CFixedOcc)
	void Check();
#endif
private:
	ulong GetNextCompressed(long &Iterator);
	void Iterate(int Index, long &Iterator);
	void IterateInSegment(int Index, long &Iterator);
	void IterateTicket();
    long InitSegmentIterator();
	void *GetTail();
		// Visual C++ does not handle protected return type

    ulong ExtractFirst()
		{ return CurBase + ((LastCompressedOcc & ~0x80000000l) >> 16); }
    ulong ExtractSecond()
	    { return CurBase + (LastCompressedOcc & 0x0000ffffl); }
};

#endif

