#if !defined(__hdoc_h)
#define __hdoc_h

#include "handler.h"
#include "docdesc.h"

class CDualMap;

class CDocHandler : public CKeyHandler
{
private:
	static CDualMap *DualMap;
public:
	CDocHandler(CDualMap *aDualMap); // deleted in destructor
	virtual ~CDocHandler();

	static KEY NewKey(const CDocDesc &DocDesc);
	static void GetDocDesc(KEY Key, CDocDesc &DocDesc);

	virtual KEY NewCopy(KEY Key);
	virtual KEY Load(KEY PrevKey, CFileObj *Stream);
	virtual void Save(KEY PrevKey, KEY Key, CFileObj *Stream);
	virtual ushort GetDiskLen(KEY PrevKey, KEY Key);
	virtual ushort GetAveKeyLen();
	virtual ushort GetAveDiskLen();

	virtual short Compare(KEY Key1, KEY Key2);

	ushort GetDiskLenReal() { return CDocDesc::GetDiskLen(); }

	void StoreAll();
	static short Has(const DString &DocName);
};

#endif

