#include "myfndt.h"
#include "hstrlong.h"

#include <string.h>

CStrLongHandler::CStrLongHandler(ushort AveStrLen):
	AveDiskLen((ushort)(sizeof(long) + sizeof(short) + AveStrLen))
{
}

CStrLongHandler::~CStrLongHandler()
{
}

KEY CStrLongHandler::NewKey(const char *Str, long Num)
{
	KEY ret = CKeyHandler::NewKey((ushort)(sizeof(long) +
		strlen(Str) + 1));
	memcpy(ret, &Num, sizeof(long));
	char *p = ((char *)ret) + sizeof(long);
	strcpy(p, Str);
	return ret;
}

void CStrLongHandler::GetStrLong(KEY Key, char *&Str, long &Num)
{
	memcpy(&Num, Key, sizeof(long));
	Str = ((char *)Key) + sizeof(long);
}

KEY CStrLongHandler::NewCopy(KEY Key)
{
	char *p = ((char *)Key) + sizeof(long);
	ushort len = (ushort)(sizeof(ulong) + strlen(p) + 1);
	KEY ret = CKeyHandler::NewKey(len);
	memcpy(ret, Key, len);
	return ret;
}

KEY CStrLongHandler::Load(KEY, CFileObj *Stream)
{	long Num;
	short StrLen;

	Stream->Read(&Num, sizeof(long));
	Stream->Read(&StrLen, sizeof(short));
	CMemPtr<char> Buf((short)(StrLen + 1));
	Stream->Read((char *)Buf, StrLen);
	*((char *)Buf + StrLen) = 0;
	return NewKey(Buf, Num);
}

void CStrLongHandler::Save(KEY, KEY Key, CFileObj *Stream)
{	long Num;
	char *Str;

	GetStrLong(Key, Str, Num);
	Stream->Write(&Num, sizeof(long));
	short StrLen = (short)strlen(Str);
	Stream->Write(&StrLen, sizeof(short));
	Stream->Write(Str, StrLen);
}

ushort CStrLongHandler::GetDiskLen(KEY, KEY Key)
{
	return GetDiskLenReal(Key);
}

ushort CStrLongHandler::GetDiskLenReal(KEY Key)
{	long Num;
	char *Str;

	GetStrLong(Key, Str, Num);
	return (ushort)(sizeof(long) + sizeof(short) + strlen(Str));
}

ushort CStrLongHandler::GetAveDiskLen()
{
	return AveDiskLen;
}

ushort CStrLongHandler::GetAveKeyLen()
{
	return (ushort)(AveDiskLen - sizeof(long) - sizeof(short));
}

short CStrLongHandler::Compare(KEY Key1, KEY Key2)
{	char *Str1, *Str2;
	long Num1, Num2;

	GetStrLong(Key1, Str1, Num1);
	GetStrLong(Key2, Str2, Num2);
	short c = (short)strcmp(Str1, Str2);
	if (c)
		return c;
	long c2 = Num1 - Num2;
	if (c2 > 0)
		return 1;
	else
		return (short)(c2 < 0 ? -1 : 0);
}

void *CStrLongHandler::AllocDiskData(KEY Key)
{	char *Str;
	long Num;

	ushort Len = GetDiskLenReal(Key);
	CMemPtr<char> Data(Len);
	GetStrLong(Key, Str, Num);
	memcpy((char *)Data, &Num, sizeof(long));
	short StrLen = (short)strlen(Str);
	memcpy((char *)Data + sizeof(long), &StrLen, sizeof(short));
	memcpy((char *)Data + sizeof(long) + sizeof(short),
		Str,
		StrLen);
	return Data.Drop();
}

KEY CStrLongHandler::NewKeyFromData(void *Data)
{	long Num;
	short StrLen;

	memcpy(&Num, Data, sizeof(long));
	memcpy(&StrLen, (char *)Data + sizeof(long), sizeof(short));
	CMemPtr<char> Buf((short)(StrLen + 1));
	memcpy((char *)Buf,
		(char *)Data + sizeof(long) + sizeof(short),
		StrLen);
	*((char *)Buf + StrLen) = 0; // gcc does not handle implicit conversion
	return NewKey((char *)Buf, Num);
}


