#include "myfndt.h"
#include "infra.h"
#include "locusopt.h"
#include "subdatum.h"
#include "subdesc.h"
#include "oinfra.h"

CInfrastructure::CInfrastructure(short OpenFlags, CLocusOptions &Options):
    CStorage(new CULongHandler,
        Options.Get(O_INFRAKEY),
        new CDatumFactoryTemplate<CSubDatum>(),
        Options.Get(O_INFRAFREE),
        Options.Get(O_INFRADAT),
        OpenFlags,
		CRemTable::DefaultLimit,
		CRemTable::DefaultDelta,
		1) // minimal cache - every doc is added (at most) once
{
}

void CInfrastructure::AddSubdocDesc(ulong Doc, CSubDesc *InSubDesc)
{
    CObjPtr<CSubDesc> SubDesc = InSubDesc;
    CNewKey Key(CULongHandler::NewKey(Doc));
	CDatumEnvelopeTemplate<CSubDatum> Envelope =
			static_cast<CSubDatum *>(LockAlways(Key));
    Envelope->SetDesc(SubDesc.Drop());
}

CSubDesc *CInfrastructure::NewSubDesc(ulong Doc)
{
    CNewKey Key(CULongHandler::NewKey(Doc));
	CDatumEnvelopeTemplate<CSubDatum> Envelope =
			static_cast<CSubDatum *>(Lock(Key));
    if (Envelope.IsEmpty())
        return NULL;
    return Envelope->NewSubDesc();
}
