#include "myfndt.h"
#include "latecase.h"

CLateOnlyCase::CLateOnlyCase(int aLateCaseConv):
    LateCaseConv(aLateCaseConv)
{
}

int CLateOnlyCase::Confine(DString &)
{
	return 0;
}

DIArray<DString> *CLateOnlyCase::NewVariate(const DString &Occ)
{	DString Var[3];
	int i;

    Assert(LateCaseConv != -1);

	if (Occ.GetLength() < 2)
		return 0;
	char C0 = Occ[0];
	if (!IsAlpha(C0))
		return 0;

	// reserve space
	for (i = 0; i < 3; i++)
		Var[i] = Occ;

	Var[Upper][0] = Var[Cap][0] = ToUpper(C0);
	Var[Lower][0] = ToLower(C0);

	int l = Occ.GetLength();
	for (i = 1; i < l; i++)
	{  char c = Occ[i];
		if (!IsAlpha(c))
			return 0;

		Var[Upper][i] = Var[Lower][i] = ToLower(c);
		Var[Cap][i] = ToUpper(c);
	}

	CObjPtr<DIArray<DString> > Variations = new DIArray<DString>(4, 0);
    Add(Variations, Occ);
    switch (LateCaseConv)
    {   case 2:
            for (i = 0; i < 3; i++)
                Add(Variations, Var[i]);
            break;
        case 1:
            Add(Variations, Var[Cap]);
            break;
        case 0:
        default:
            break;
	}
	return Variations.Drop();
}

void CLateOnlyCase::Add(DIArray<DString> *Variations, const DString &Var)
{
    if (Variations->Find(const_cast<DString *>(&Var)) == INT_MAX)
		Variations->Add(new DString(Var));
}
