#if !defined(__packer_h)
#define __packer_h

class CPacker
{
public:
    CPacker();

    int GetPackedCount(ulong *OccArray, int Count);
    void Pack(ulong *OccArray, int &Count);
    ulong *AllocMerge(ulong *Occ1, int Count1, ulong *Occ2, int Count2, 
            int &OutCount);
    ulong *AllocAdd(ulong *PackedArr, int PackedCount, ulong *SparseArr,
		  int SparseCount, int &OutCount);

    int MergeOverflows(long Count1, long Count2)
   	    { return (Count1 + Count2) * sizeof(ulong) >= 32767; }
    int AddOverflows(long Count1, long Count2) // see also GetUpperBound
	    { return (2 * Count1 + Count2) * sizeof(ulong) >= 32767; }

private:
    ulong *AllocAddComposed(ulong *Squeezed, int SqueezedCount, ulong *Potencial,
		  int PotencialCount, ulong *Sparse, int SparseCount, int &OutCount);
    void UnpackStep(ulong *&Dest, ulong *&Src);
    static int GetUpperBound(int PackedCount) // see also AddOverflows
   	    { return 2 * PackedCount; }
    static ulong ExtractFirst(ulong CurBase, ulong Compressed)
	    { return CurBase + ((Compressed & ~0x80000000l) >> 16); }
    static ulong ExtractSecond(ulong CurBase, ulong Compressed)
	    { return CurBase + (Compressed & 0x0000ffffl); }
};

#endif










