#include "myfndt.h"
#include "punctaxe.h"

#include <string.h>
    // just for assertions

CPunctAxe::CPunctAxe(const DString &aPunct):
	Punct(aPunct.GetLength(), 0)
{
	int Len = aPunct.GetLength();
	for (int i = 0; i < Len; i++)
		Punct.Add(aPunct[i]);
}

CPunctAxe::~CPunctAxe()
{
}

int CPunctAxe::AxePunct(DString &OccWord)
{
    int s = OccWord.GetLength() + 1;
    CMemPtr<char> Buffer(s);
    memcpy((char *)Buffer, OccWord.c_str(), s);
    char *w = (char *)Buffer;

    while (*w && IsPunct(*w))
        ++w;
    if (!(*w))
        return 1;

    char *e = strchr(w, 0) - 1;
    while (IsPunct(*e))
        *e-- = 0;

    Assert(e >= w);
    OccWord = w;
    return 0;
}
/*{	int len;

	while (OccWord.GetLength() > 1 &&
		IsPunct(OccWord[0]))
		CutHead(OccWord);
	while ((len = OccWord.GetLength()) > 1 &&
		IsPunct(OccWord[len - 1]))
		CutTail(OccWord);

	return OccWord.GetLength() == 1 && IsPunct(OccWord[0]);
}*/

int CPunctAxe::IsPunct(char C)
{
	return Punct.Find(C) != INT_MAX;
}

/*void CPunctAxe::CutHead(DString &Str)
{
#if defined(__BORLANDC__)
	Str.remove(0, 1);
#else
#if defined(__GNUG__) && !defined(USE_OWN_STRING)
    DString OldStr = Str;
    Str = DString(Str.after((int)0));
	Assert(!strcmp(OldStr.c_str() + 1, Str.c_str()));
#else
	Assert(!Str.IsEmpty());
	Str = Str.Right(Str.GetLength() - 1);
#endif
#endif
}

void CPunctAxe::CutTail(DString &Str)
{
#if defined(__BORLANDC__)
	Str.remove(Str.GetLength() - 1);
#else
#if defined(__GNUG__) && !defined(USE_OWN_STRING)
	DString OldStr = Str;
    Str = DString(Str.before((int)(Str.GetLength() - 1)));
	Assert(!strncmp(OldStr.c_str(), Str.c_str(), Str.GetLength()));
#else
	Assert(!Str.IsEmpty());
	Str = Str.Left(Str.GetLength() - 1);
#endif
#endif
}*/

