#include "myfndt.h"
#include "spider.h"

const long CSpider::CompressableMax = 0xffffl;

CSpider::CSpider(ulong *aOccArray, int aCount, int aReallyPack):
    OccArray(aOccArray),
    CurBase(aOccArray[0]),
    Src(aOccArray + 1),
    Dest(aOccArray + 1),
    LastItem(aOccArray + aCount - 1),
    CurCount(aCount),
    OrigCount(aCount),
    ReallyPack(aReallyPack)
{
}

void CSpider::Pack()
{
	while (LastItem - Src > 0)
	    Step();
	if (ReallyPack &&
	    (Src == LastItem && CurCount < OrigCount))
	    OccArray[CurCount - 1] = *LastItem;
}

void CSpider::Step()
{
    Assert(*Src >= CurBase);
    ulong Delta1 = *Src - CurBase;
    Assert(*(Src + 1) >= *Src);
    ulong Delta2 = *(Src + 1) - *Src;
    if (Delta1 < CompressableMax / 2 &&
	   Delta2 <= CompressableMax)
    {   CurBase = *(Src + 1);
	   if (ReallyPack)
		  *Dest = Compress(Delta1, Delta2); // overrides *Src
	   Src += 2;
	   CurCount--;
    }
    else
    {   CurBase = *Src;
	   if (ReallyPack)
		  *Dest = *Src;
	   Src++;
    }
    Dest++;
}
