#if !defined(__watch_h)
#define __watch_h

#include "rxw.h"
#include "vector.h"

class CLocusOptions;
class CUnivOptions;
class CChange;
class CStringListValue;

class CWatch
{
public:
    CWatch(const CRegex &aDocBegin = CRegex(DString("")), short aMargin = 0);
	// w/o subdocs - for grazer
    CWatch(CLocusOptions &Options);
        // full - for cruncher

    static void SetSubdocClass(CUnivOptions &Options,
	const CStringListValue &DocParts);

    short GetMargin() const;
    short GetValidSize(const char *Chunk, short ReadSize, int FromBegin);
    void Iterate(const char *Chunk, CChange &Change);

private:
    class CRegexArray : public vector<CRegex>
    {
    public:
	CRegexArray();
	
	void Add(const DString &Regex, int IgnoreCase);
    };

    short Margin;
    CRegex DocBegin;
    CRegexArray PushMatch;
    CRegexArray PopMatch;

    // returns 0 no match, 1 found match (out params valid)
    int GetPushMatch(const char *Chunk,
        int &From, // out
	int &To, // out
	short &SubdocId); // out
    // returns 0 no match, 1 found match (out params valid)
    int GetPopMatch(const char *Chunk,
	short Subdoc, // must not be 0 (plaintext)
        int &From, // out
	int &To); // out
};

#endif
