#if !defined(__fileobj_h)
#define __fileobj_h

#include <stdio.h>

class CFileObj
{
private:
	FILE *Handle;
public:
	CFileObj(const char *FName, const char *Flags);
	CFileObj(FILE *aHandle);
	virtual ~CFileObj();
	void Open(const char *FName, const char *Flags);
	void Assign(FILE *aHandle);
	short IsAssigned() { return Handle != 0; }

	void Seek(long Offs, int Whence = SEEK_SET);
	void Write(const void *Ptr, size_t Size, size_t Num = 1);
	void Read(void *Ptr, size_t Size, size_t Num = 1);
	long Tell();
	void Flush();
	void WriteZero(long Size);
	void Close() { Done(); }
	void Print(const char *Format, ...);

private:
	void Init(const char *FName, const char *Flags);
	void Done();
};

#endif

