#if !defined(__smartptr_h)
#define __smartptr_h

#if defined(EXTERNAL_TEMPLATES)
#pragma interface
#endif

/*class CCharArr
{
private:
	char *Ptr;

	// this is private because it's forbidden
	CCharArr &operator = (CCharArr &Src) { return Src; }
public:
	CCharArr(char *aPtr): Ptr(aPtr) { }
	virtual ~CCharArr();

	operator char *() { return Ptr; }
};*/

class CMemPtrCode
{
protected:
	void *Ptr;

	CMemPtrCode(void *aPtr = 0): Ptr(aPtr) { }
	CMemPtrCode(short Size);
	CMemPtrCode &operator = (void *aPtr);

	virtual ~CMemPtrCode();
};

template<class CDeref>
class CMemPtr : public CMemPtrCode
{
private:
	CMemPtr &operator = (CMemPtr &Src); // not implemented

public:
	CMemPtr(CDeref *aPtr = NULL): CMemPtrCode(aPtr) { }
	CMemPtr(short Size): CMemPtrCode(Size) { }
	CMemPtr &operator = (CDeref *aPtr)
		{ CMemPtrCode::operator =(aPtr); return *this; }

	operator CDeref *()
		{ return reinterpret_cast<CDeref *>(Ptr); }
	CDeref *Drop()
		{ CDeref *Q = reinterpret_cast<CDeref *>(Ptr); Ptr = 0;
				return Q; }
};

class CObjPtrCode
{
protected:
	void *Ptr;

	CObjPtrCode(void *aPtr = 0): Ptr(aPtr) { }
	virtual ~CObjPtrCode();
};

template<class CDeref>
class CObjPtr : public CObjPtrCode
{
private:
	CObjPtr &operator = (CObjPtr &Src); // not implemented

public:
	CObjPtr(CDeref *aPtr = NULL): CObjPtrCode(aPtr) { }
	virtual ~CObjPtr()
		{ delete reinterpret_cast<CDeref *>(Ptr); }
	CObjPtr &operator = (CDeref *aPtr)
		{ delete reinterpret_cast<CDeref *>(Ptr);	Ptr = aPtr;
			return *this; }

	operator CDeref *()
		{ return reinterpret_cast<CDeref *>(Ptr); }
	CDeref *operator->()
		{ return reinterpret_cast<CDeref *>(Ptr); }
			// should throw exception if Ptr == 0
	CDeref *Drop()
		{ CDeref *Q = reinterpret_cast<CDeref *>(Ptr); Ptr = 0;
				return Q; }
};

#endif

