#if !defined(__txcpt_h)
#define __txcpt_h

//#include "cstr.h" see myfndt.h

#if defined(__BORLANDC__)
#include <except.h>
#else
#if defined(__GNUG__)
#include "h_except.h"
#else
#include <stdexcpt.h>
#endif
#endif

#if !defined(_MSC_VER)
typedef xmsg DException;
#else
typedef exception DException;
#endif

class CGeneralException : public DException
{
public:
    CGeneralException(const char *Text = "general");
    CGeneralException(const CGeneralException &Source);
    virtual ~CGeneralException();
    CGeneralException &operator = (CGeneralException &Source);
};

class DMemoryException : public 
#if !defined(_MSC_VER)
	xalloc
#else
	DException
#endif
{
public:
	DMemoryException(size_t size = 0);
	DMemoryException(const DMemoryException &Source);
	DMemoryException &operator = (DMemoryException &Source);

#if defined(_MSC_VER)
public:
	size_t requested() { return Size; }
private:
	size_t Size;
#endif
};

class COpenException : public DException
{
public:
    COpenException(const DString &aFile, const DString &aMode);
    COpenException(const COpenException &Source);
    COpenException &operator = (COpenException &Source);

    const char *GetFile();
    const char *GetMode();

private:
    DString File;
    DString Mode;
};

class CReadException : public DException
{
public:
    CReadException();
    CReadException(const CReadException &Source);
    CReadException &operator = (CReadException &Source);
};

class CWriteException : public DException
{
public:
    CWriteException();
    CWriteException(const CWriteException &Source);
    CWriteException &operator = (CWriteException &Source);
};

class DAssertException : public DException
{
private:
    DString File;
    int Line;

public:
    DAssertException(const char *aFile, int aLine);
    DAssertException(const DAssertException &Source);
    DAssertException &operator = (DAssertException &Source);

    DString GetFile() { return File; }
    int GetLine() { return Line; }
};

#endif
