#include "myfndt.h"
extern "C"
{
#include "buildqe.h"
};
#include "qebb.h"
#include "binpar.h"
#include "sdlpar.h"

//#define DEBUG_evasion

char *SetSoftOpName(char *InName)
{
#if defined(DEBUG_evasion)
    printf("SetSoftOpName(%s)\n", InName);
#endif
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticSetSoftOpName,
        reinterpret_cast<void *>(InName));
}

char *AddSoftOpArgs(char *InString)
{
#if defined(DEBUG_evasion)
    printf("AddSoftOpArgs(%s)\n", InString);
#endif
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticAddSoftOpArgs,
	   reinterpret_cast<void *>(InString));
}

char *CreateTerm(void **Formula)
{
#if defined(DEBUG_evasion)
    printf("CreateTerm\n");
#endif
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticCreateTerm,
        reinterpret_cast<void *>(Formula));
}

char *CreateBinary(int Op,
    void *LeftFormula,
    void *RightFormula,
    void **OutFormula)
{
#if defined(DEBUG_evasion)
    printf("CreateBinary\n");
#endif
    SBinaryPar *BinaryPar = (SBinaryPar *)malloc(sizeof(SBinaryPar));
    if (BinaryPar)
    {   BinaryPar->Op = Op;
        BinaryPar->Left = reinterpret_cast<CFormulaBase *>(LeftFormula);
        BinaryPar->Right = reinterpret_cast<CFormulaBase *>(RightFormula);
        BinaryPar->Out = reinterpret_cast<CFormulaBase **>(OutFormula);
    }
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticCreateBinary,
        reinterpret_cast<void *>(BinaryPar));
}

char *SetFinalFormula(void *Formula)
{
#if defined(DEBUG_evasion)
    printf("SetFinalFormula\n");
#endif
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticSetFinalFormula,
	   Formula);
}

char *ResetSoftOpName()
{
#if defined(DEBUG_evasion)
    printf("ResetSoftOpName\n");
#endif
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticResetSoftOpName,
	   NULL);
}

// should call something in CQueryBuilderBase, which would return localizable text
// and handle memory exhaustion
char *AllocUnquotedError(int WrongChar)
{
#if defined(DEBUG_evasion)
    printf("AllocUnquotedError\n");
#endif
    char *Format = "invalid character \'%c\' in unquoted argument";
    char *Buf = (char *)malloc(strlen(Format) + 1);
    if (!Buf)
	   return NULL;

    sprintf(Buf, Format, WrongChar);
    return Buf;
}

char *CreateSubdocList(SRestrictedDomain **OutList, char *InName)
{
#if defined(DEBUG_evasion)
    printf("CreateSubdocList(?, %s)\n", InName);
#endif
    SCreateSDPar *SubdocListPar = (SCreateSDPar *)malloc(sizeof(SCreateSDPar));
    if (SubdocListPar)
    {   SubdocListPar->InName = InName;
        SubdocListPar->Out = OutList;
    }
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticCreateSubdocList,
        reinterpret_cast<void *>(SubdocListPar));
}

char *AddSubdocName(SRestrictedDomain *List, char *InName)
{
#if defined(DEBUG_evasion)
    printf("AddSubdocName(?, %s)\n", InName);
#endif
    SAddSDPar *AddSDPar = (SAddSDPar *)malloc(sizeof(SAddSDPar));
    if (AddSDPar)
    {   AddSDPar->List = List;
        AddSDPar->InName = InName;
    }
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticAddSubdocName,
        reinterpret_cast<void *>(AddSDPar));
}

char *CreateRestrictedTerm(SRestrictedDomain *InList, void **OutFormula)
{
#if defined(DEBUG_evasion)
    printf("CreateRestrictedTerm\n");
#endif
    SRestrictedTermPar *Par = (SRestrictedTermPar *)malloc(
            sizeof(SRestrictedTermPar));
    if (Par)
    {   Par->In = InList;
        Par->Out = reinterpret_cast<CFormulaBase **>(OutFormula);
    }
    return CQueryBuilderBase::Global->SafeCall(
        CQueryBuilderBase::StaticCreateRestrictedTerm,
        reinterpret_cast<void *>(Par));
}
