#if !defined(__buildqe_h)
#define __buildqe_h

#include "restdom.h"

// return malloc'ed string on error; in pointers are freed by callee,
// formula pointers (in & out) are owned by callee

char *SetSoftOpName(char *InName);
    // input == NULL => out of memory
char *AddSoftOpArgs(char *InString);
    // input == NULL => out of memory
    // string may contain more than 1 word (white-character delimited)
char *CreateTerm(void **OutFormula);
char *CreateBinary(int Op,
    void *LeftFormula,
    void *RightFormula,
    void **OutFormula);
char *SetFinalFormula(void *Formula);
char *ResetSoftOpName();

char *AllocUnquotedError(int WrongChar);

// for subdocs
char *CreateSubdocList(SRestrictedDomain **OutList, char *InName);
char *AddSubdocName(SRestrictedDomain *List, char *InName);
char *CreateRestrictedTerm(SRestrictedDomain *InList, void **OutFormula);

#endif
