%{
#include "restdom.h"
#include "quexprt.h"
#include "pqerr.h"

#include <stdlib.h>
#include <string.h>

static char *GetName(void);
static char *GetStr(void);
%}

ID [a-zA-Z][a-zA-Z0-9_]*

UNQSTR \"[^"\n]*\"

%%

{ID} { 
    yqlval.sval = GetName();
    return NAME; 
   }

{UNQSTR}+ { 
    yqlval.sval = GetStr();
    return STRING; 
   }

[ \t] /* skip */;

\n { query_parser_line++; }

"$" { 
    return 0; 
    }

. { return yqtext[0]; }

%%

static char *GetName()
{   int Size;
    char *GBuffer;

    Size = strlen(yqtext) + 1; 
    GBuffer = (char *)malloc(Size);
    if (!GBuffer)
	return NULL;

    memcpy(GBuffer, yqtext, Size);
    return GBuffer;
}

static char *GetStr()
{   char *src;
    char *p;
    char *uq;
    int Size;
    char *GBuffer;

    src = yqtext + 1;
    Size = strlen(src) + 1;
    GBuffer = (char *)malloc(Size);
    if (!GBuffer)
	return NULL;

    memcpy(GBuffer, src, Size);
    uq = GBuffer;
    while ((p = strchr(uq, '\"')) != NULL)
    {   if (*(p + 1) == 0)
            *p = 0;
        else  
        {   memmove(p, p + 1, strlen(p + 1) + 1);
            uq = p + 1;
        }
    }
    return GBuffer;
}



