#include "myfndt.h"
#include "book.h"

CBook::CBook(CKeyHandler *aKeyHandler, const DString &FName, ushort Opt):
	CTree(aKeyHandler, FName, Opt),
	LockKeyCount(0)
{
}

short CBook::UnlockKey(KEY Key)
{
	short ret = Root->UnlockKey(Key);
	if (!ret)
	{	Assert(LockKeyCount);
		LockKeyCount--;
	}
	return ret;
}

short CBook::GetData(KEY Key, LONG &Data)
{
	return Root->GetData(Key, Data);
}

short CBook::Add(KEY Key, LONG Data)
{
	// locked key is actually a locked node; when adding new key,
	// locked key could move to another node
	Assert(!LockKeyCount);

/*	if (CItem::GetDiskHeaderLen() + KeyHandler->GetDiskLen(0, Key) >
		(Root->GetBlockLen() - Root->GetNodeHdrLen() - sizeof(ushort)) / 2) // / 2 is reserve
		return 2;*/

	return Root->Add(Key, Data);
}

short CBook::Del(KEY Key)
{
	// locked key is actually a locked node; when deleting old
	// key, locked key could move to another node
	Assert(!LockKeyCount);

	return Root->Del(Key);
}

#if defined(DEBUG_CNode)
void CBook::Check()
{	ushort Path[100];

	Root->Check(0, Path);
}
#endif

KEY CBook::UnivLock(KEY Key)
{
	if (Key)
		LockKeyCount++;
	return Key;
}

