#include "myfndt.h"
#include "chaina.h"

/*#if !defined(_MSC_VER)
#include <alloc.h>
#endif*/
#include <stdlib.h>

void CChainAllocator::SBlock::FreeNext()
{
     if (Next)
	{    Next->FreeNext();
		free(Next);
		Next = NULL;
	}
}

CChainAllocator::CChainAllocator(size_t aBlockSize, int aMaxChain):
     BlockSize(aBlockSize),
	Chain(NULL),
	MaxChainCount(aMaxChain),
	CurChainCount(0)
{
     Assert(BlockSize >= sizeof(SBlock) && MaxChainCount > 0);
}

CChainAllocator::~CChainAllocator()
{
     if (Chain)
	{    Chain->FreeNext();
		free(Chain);
	}
}

void *CChainAllocator::Alloc(size_t aBlockSize)
{
     Assert(aBlockSize == BlockSize);
	if (Chain)
	{    void *Ptr = Chain;
		Chain = Chain->Next;
		CurChainCount--;
		return Ptr;
	}
	else
	{    void *NewPtr = malloc(BlockSize);
		if (!NewPtr)
		    throw DMemoryException(BlockSize);
		return NewPtr;
	}
}

void CChainAllocator::Free(void *Ptr)
{
     if (CurChainCount < MaxChainCount)
     {    ((SBlock *)Ptr)->Next = Chain;
		Chain = (SBlock *)Ptr;
		CurChainCount++;
	}
	else
	     free(Ptr);
}
