#include "myfndt.h"
#include "hstr.h"

#include <string.h>

CStringHandler::CStringHandler(ushort aAveKeyLen):
	AveKeyLen(aAveKeyLen)
{
    Assert(AveKeyLen > 0);
}

KEY CStringHandler::NewKey(const char *Str)
{
    Assert(Str != NULL);
	int l = strlen(Str);
	KEY ret = CKeyHandler::NewKey((ushort)(l + 1));
	memcpy(ret, Str, l + 1);
	return ret;
}

KEY CStringHandler::NewCopy(KEY Key)
{	ushort l;
	KEY ret;

    Assert(Key != NULL);
	l = GetKeyStrLen(Key);
	ret = CKeyHandler::NewKey((ushort)(l + 1));
	memcpy(ret, Key, l + 1);
	return ret;
}

KEY CStringHandler::Load(KEY, CFileObj *Stream)
{	ushort l;
	KEY Key;

	Stream->Read(&l, sizeof(ushort));
	Key = CKeyHandler::NewKey((ushort)(l + 1));
	Stream->Read(Key, l);
	*(((char *)Key) + l) = '\0';
	return Key;
}

void CStringHandler::Save(KEY, KEY Key, CFileObj *Stream)
{
	ushort l = GetKeyStrLen(Key);

	Stream->Write(&l, sizeof(ushort));
	Stream->Write(Key, l);
}

ushort CStringHandler::GetDiskLen(KEY, KEY Key)
{
	return (ushort)(sizeof(ushort) + GetKeyStrLen(Key));
}

ushort CStringHandler::GetAveDiskLen()
{
	return (ushort)(sizeof(ushort) + AveKeyLen);
}

ushort CStringHandler::GetAveKeyLen()
{
	return AveKeyLen;
}

short CStringHandler::Compare(KEY Key1, KEY Key2)
{
	return (short)strcmp(reinterpret_cast<char *>(Key1),
		reinterpret_cast<char *>(Key2));
}

ushort CStringHandler::GetKeyStrLen(KEY Key)
{
	return (ushort)strlen((char *)Key);
}

