#include "myfndt.h"
#include "hulong.h"

KEY CULongHandler::NewKey(ulong Num)
{
	KEY ret = CKeyHandler::NewKey(sizeof(ulong));
	memcpy(ret, &Num, sizeof(ulong));
	return ret;
}

KEY CULongHandler::NewCopy(KEY Key)
{
    Assert(Key != NULL);
	KEY ret = CKeyHandler::NewKey(sizeof(ulong));
	memcpy(ret, Key, sizeof(ulong));
	return ret;
}

KEY CULongHandler::Load(KEY, CFileObj *Stream)
{
	KEY Key = CKeyHandler::NewKey(sizeof(ulong));
	Stream->Read(Key, sizeof(ulong));
	return Key;
}

void CULongHandler::Save(KEY, KEY Key, CFileObj *Stream)
{
	Stream->Write(Key, sizeof(ulong));
}

ushort CULongHandler::GetDiskLen(KEY, KEY)
{
	return sizeof(ulong);
}

ushort CULongHandler::GetAveDiskLen()
{
	return sizeof(ulong);
}

ushort CULongHandler::GetAveKeyLen()
{
	return sizeof(ulong);
}

short CULongHandler::Compare(KEY Key1, KEY Key2)
{
	ulong c1 = GetULong(Key1);
	ulong c2 = GetULong(Key2);
	if (c1 == c2)
		return 0;
	else
		return (short)(c1 < c2 ? -1 : 1);
}

