#include "myfndt.h"
#include "lockptr.h"
#include "handler.h"
#include "node.h"
#include <string.h>

CLockedPtr::CLockedPtr(CNode *aPtr, CTree *aTree):
	Tree(aTree), Ptr(aPtr)
{
}

CLockedPtr::~CLockedPtr()
{
	// unlock only if not dropped
	if (Ptr)
		Tree->UnlockNode(Ptr);
}

CNode *CLockedPtr::operator->()
{
	Assert(Ptr != NULL);
	return Ptr;
}

CItem **AllocInfo()
{
	CItem **Info = (CItem **)malloc(CNode::MaxInfo * sizeof(CItem *));
	if (!Info)
		throw DMemoryException(CNode::MaxInfo * sizeof(CItem *));
	memset(Info, 0, CNode::MaxInfo * sizeof(CItem *));
	return Info;
}

void FreeInfo(CItem **Info)
{	short i;
	CItem **InfoPtr;

	Assert(Info != NULL);
	for (i = 0, InfoPtr = Info; 
		i < CNode::MaxInfo && *InfoPtr; 
		i++, InfoPtr++)
		delete *InfoPtr;
	free(Info);
}

CInfoPtr::CInfoPtr(CItem **aPtr):
	Ptr(aPtr)
{
}

CInfoPtr::~CInfoPtr()
{
	if (Ptr)
		FreeInfo(Ptr);
}

CItem **CInfoPtr::operator = (CItem **Src)
{
	if (Ptr)
		FreeInfo(Ptr);
	return Ptr = Src;
}


