#if !defined(__lockptr_h)
#define __lockptr_h

#include "tltype.h"
#include "tltree.h"

class CLockedPtr
{
private:
	CTree *Tree;
	CNode *Ptr;

	// not implemented
	CLockedPtr &operator = (CLockedPtr &Src);
public:
	CLockedPtr(CNode *aPtr, CTree *aTree);
	virtual ~CLockedPtr();

	operator CNode *() { return Ptr; }
	CNode *operator->();
	inline CNode *operator = (CNode *Src);
	CNode *Drop() { CNode *Q = Ptr; Ptr = 0; return Q; }
};

CItem **AllocInfo();
void FreeInfo(CItem **Info);

class CInfoPtr
{
private:
	CItem **Ptr;

	// this is private because it's forbidden
	CInfoPtr &operator = (CInfoPtr &Src) { return Src; }
public:
	CInfoPtr(CItem **aPtr);
	virtual ~CInfoPtr();

	operator CItem **() { return Ptr; }
	CItem **operator = (CItem **Src);
	CItem **Drop() { CItem **Q = Ptr; Ptr = 0; return Q; }
};

CNode *CLockedPtr::operator = (CNode *Src)
{
	// unlock only if not dropped
	if (Ptr)
		Tree->UnlockNode(Ptr);
	return Ptr = Src;
}

#endif
