#include "myfndt.h"
#include "opendata.h"
#include "tempfile.h"
#include <stdio.h>

int OpenData(const DString &PathName,
    ushort Opt,
    DString &FName, // out
    CFileObj &Stream)
{
	Assert(!(Opt & IT_CREATE) || (Opt & IT_UPDATE));

	if (Opt & IT_TEMP)
	{	FName = GetTemporaryFile(PathName);
	        Stream.Open(FName.c_str(), "w+b");
		return 1;
	}
	else
	{	FName = PathName;
        const char *Mode = (Opt & IT_UPDATE) ? "r+b" : "rb";
	    FILE *Handle = fopen(FName.c_str(), Mode);
		if (!Handle)
		{	if (Opt & IT_CREATE)
            {   Stream.Open(FName.c_str(), "w+b");
                return 1;
			}
			else
				throw COpenException(FName, DString(Mode));
		}
		else
		{  Stream.Assign(Handle);
           return 0;
		}
	}
}
