#include "myfndt.h"
#include "remnodes.h"

/*#if !defined(_MSC_VER)
#include <alloc.h>
#endif*/
#include <stdlib.h>

CSortedNode::CSortedNode(long aOffs, long aParent, CTree *aTree,
		ushort aAveLen):
	CNode(aOffs, aParent, aTree, aAveLen),
	LockCount(0)
{
}

CSortedNode::CSortedNode(long aOffs, long aParent, CTree *aTree,
		CItem **aInfo, ushort aCount, long aLastChild, ushort aAveLen):
	CNode(aOffs, aParent, aTree, aInfo, aCount, aLastChild, aAveLen),
	LockCount(0)
{
}

CSortedNode::CSortedNode(long aOffs, CTree *aTree, CFileObj *Stream):
	CNode(aOffs, aTree, Stream),
	LockCount(0)
{
}

#if defined(NOCPCONSTRUCT)
int CSortedNode::operator == (const CSortedNode *Other)
{
	return GetOffs() == Other->GetOffs();
}

int CSortedNode::operator < (const CSortedNode *Other)
{
	return GetOffs() < Other->GetOffs();
}

int CSortedNode::operator > (const CSortedNode *Other)
{
	return GetOffs() > Other->GetOffs();
}
#endif

#if defined(DEBUG_new)
void *CSortedNode::operator new(size_t Size)
{
	Assert(Size == sizeof(CSortedNode));
		// we need to know the size in operator delete
	void *Ptr = malloc(sizeof(CSortedNode));
	if (!Ptr)
		throw DMemoryException(sizeof(CSortedNode));
	memset(Ptr, 0x10, sizeof(CSortedNode));
	return Ptr;
}

void CSortedNode::operator delete(void *Ptr)
{
	memset(Ptr, 0x33, sizeof(CSortedNode));
	free(Ptr);
}
#endif

