#if !defined(__remnodes_h)
#define __remnodes_h

#include "arrays.h"

#include "tltype.h"
#include "node.h"
#include "factory.h"

class CSortedNode : public CNode
{	friend CNodeFactory;

private:
	ushort LockCount;

	CSortedNode(CSortedNode &Other); // no copy constructor
protected:
	CSortedNode(long aOffs, long aParent, CTree *aTree, ushort aAveLen);
	CSortedNode(long aOffs, long aParent, CTree *aTree, CItem **aInfo,
			ushort aCount, long aLastChild, ushort aAveLen);
	CSortedNode(long aOffs, CTree *aTree, CFileObj *Stream);
public:
	virtual ~CSortedNode() { }

#if defined(NOCPCONSTRUCT)
	int operator == (const CSortedNode *Other);
	int operator < (const CSortedNode *Other);
	int operator > (const CSortedNode *Other);
#else
	int operator == (const CSortedNode &Other) const
		{ return GetOffs() == Other.GetOffs(); }
	int operator < (const CSortedNode &Other) const
		{ return GetOffs() < Other.GetOffs(); }
#endif
	inline void IncLockCount() { LockCount++; }
	inline short DecLockCount()
		{ return (short)(!LockCount ? 0 : --LockCount == 0); }
	inline short IsLocked() { return LockCount > 0; }

#if defined(DEBUG_new)
	void *operator new(size_t Size);
	void operator delete(void *Ptr);
#endif
};

#endif
