#if !defined(__messform_h)
#define __messform_h

#include <vector.h>

class CFormatBase : protected vector<vector<char> >
{
protected:
    CFormatBase();

public:
    CFormatBase &operator << (const DString &Var);
    CFormatBase &operator << (const char *Var);
    CFormatBase &operator << (int Var);
    CFormatBase &operator << (long Var);
    CFormatBase &operator << (double Var);

protected:
    vector<char> GetMessageIntern(const DString &Template);    
};

class CFormatRaw : public CFormatBase
{
public:
    CFormatRaw();

    inline CFormatRaw &operator << (const DString &Var);
    inline CFormatRaw &operator << (const char *Var);
    inline CFormatRaw &operator << (int Var);
    inline CFormatRaw &operator << (long Var);
    inline CFormatRaw &operator << (double Var);

    CFormatRaw &operator << (const vector<char> &Var);
    inline vector<char> GetMessage(const DString &Template)
        { return CFormatBase::GetMessageIntern(Template); }
};

inline CFormatRaw &CFormatRaw::operator << (const DString &Var)
    { return static_cast<CFormatRaw &>(CFormatBase::operator<<(Var)); }
inline CFormatRaw &CFormatRaw::operator << (const char *Var)
    { return static_cast<CFormatRaw &>(CFormatBase::operator<<(Var)); }
inline CFormatRaw &CFormatRaw::operator << (int Var)
    { return static_cast<CFormatRaw &>(CFormatBase::operator<<(Var)); }
inline CFormatRaw &CFormatRaw::operator << (long Var)
    { return static_cast<CFormatRaw &>(CFormatBase::operator<<(Var)); }
inline CFormatRaw &CFormatRaw::operator << (double Var)
    { return static_cast<CFormatRaw &>(CFormatBase::operator<<(Var)); }

class CFormatString : public CFormatBase
{
public:
    CFormatString();

    DString GetMessage(const DString &Template);
    char *AllocMessage(const DString &Template);
};

#endif
