#include "myfndt.h"
#include "timerep.h"
#include <stdio.h>
#include "messform.h"

CEvolvedReporter::CEvolvedReporter(time_t aDelta, const DString &aFormat):
    Current(time(NULL)),
    Delta(aDelta),
    Format(aFormat),
    Total(0)
{
}

void CEvolvedReporter::ReportProgress(short, short Perc)
{
    time_t NowTime = time(NULL);
    Assert(NowTime >= Current);
    time_t NowDelta = NowTime - Current;
    if (NowDelta < Delta)
	   return;

    Current = NowTime;
    if (Perc < 0)
	   Perc = 0;
    else
	   if (Perc > 100)
		  Perc = 100;

    CFormatString Par;
    Par << Total << Perc;
    DString Message = Par.GetMessage(Format);
    printf("%s", Message.c_str());
}

void CEvolvedReporter::ReportIn()
{
    Total++;
}

void CEvolvedReporter::Reset()
{
    Current = time(NULL);
}
