#include "myfndt.h"
#include "tmpdir.h"
#include "lversion.h"
#include "otmp.h"
#include "locusopt.h"

#if defined(PLATFORM_DOS)
static DString DosGetTempDir();
#endif

DString GetTempDir(COptions<DString> *Options,
    const char *Key)
{
    DString Expl = GetDirectoryFromKey(Options, O_EXPLICITTEMPDIR);
    if (!Expl.IsEmpty())
	   return Expl;

#if defined(PLATFORM_LINUX)
    return DString("/tmp/");
#else
#if defined(PLATFORM_DOS)
    DString Impl = DosGetTempDir();
    Assert(!Impl.IsEmpty());
    if (Impl[Impl.GetLength() - 1] != '\\')
	   Impl += '\\';
    return Impl;
#else
#if defined(PLATFORM_WIN32)
	char Buf[257];

	DWORD ret = GetTempPath(256, Buf);
	if (!ret || ret >= 256 || Buf[0] == 0)
		throw CGeneralException("no temp directory");
	if (Buf[strlen(Buf) - 1] != '\\')
		strcat(Buf, "\\");
	return DString(Buf);
#else
#error define temp directory algorithm
#endif
#endif
#endif
}

#if defined(PLATFORM_DOS)
static DString DosGetTempDir()
{   char *Dir;

    if ((Dir = getenv("TEMP")) != NULL)
	   return DString(Dir);
    if ((Dir = getenv("TMP")) != NULL)
	   return DString(Dir);
    return DString("c:\\");
}
#endif
